
--XNvg[h
--_G.OnReload = function() print("camera _G.OnReload") end

--JSNX
Class("camera")({})

--RXgN^
function camera:constructor(...)

	--oϐ
	self.mCount = 0                        --JE^
	self.mPosition = Vector3C(0, 0, 0)     --ʒu
	self.mPrePosition = Vector3C()         --Öʒu
	self.mAt = Vector3C(0, 0, -200)        --_
	self.mTempPosition = Vector3C(0, 0, 0) --bʒu
	self.mTempAt = Vector3C(0, 0, -200)    --b莋_
	self.mHeight = 100                      --
	self.mHeightNext = 0                    --
	self.mHeightStart = 0                   --ύXJn
	self.mHeightMax = 2                     --őiK
	self.mHeightMin = -1                    --ŏiK
	self.mHeightNum = 0                     --ݒiK
	self.mHeightPos = 100                   --݈ʒu
	self.mMatrix = MatrixC()               --s
	self.mAngleY = 0                       --Y]px
	self.mAngleYNext = 0                   --Y]px
	self.mAngleYStart = 0                  --Y]Jn
	self.mHeightTrans = MatrixC()           --s
	self.mRollTrans = MatrixC()            --Os
	self.mRotate = MatrixC()               --Y]s
	self.mStartPos = Vector3C()            --ړJnW
	self.mStartAt = Vector3C()             --ړJn_
	self.mBackState = state:factory()      --̉鏈̏
	self.mMoveState = state:factory()      --Jړ

	--ݒ
	self.mRollTrans:Translation(0, 0, 150) --l
end

--fXgN^iOR[j
function camera:destructor()
end

--XVyړtO, L̈ʒu, L̊px, L̃Xs[h, oXgz
function camera:Run(moveFlag, charaPos, charaAng, charaSpeed, visualList)

	--Öʒuێ
	self.mPrePosition:Set(self.mPosition)

	--JړłȂꍇAf
	if self.mMoveState.mFlag == false then

		--J̈ʒuE_vZ
		self:GetPosAt(not self.mMoveState.mFlag, moveFlag, charaPos, charaAng, charaSpeed, visualList)

		--f
		self.mPosition:Set(self.mTempPosition)
		self.mAt:Set(self.mTempAt)
	end

	--J̈ړԂ̍XV
	self.mMoveState:CountUp(1)

	--JEgAbv
	self.mCount = self.mCount + 1
end

--J̋ݒ肷yJƃL̋z
function camera:SetRange(range)
	self.mRollTrans:Translation(0, 0, range)
end

--J̊pxݒ肷yJ̊pxz
function camera:SetAngle(angle)
	self.mAngleY      = angle
	self.mAngleYNext  = angle
	self.mAngleYStart = self.mCount - 26
end

--J̈ʒuE_vZ
--y͂𔽉f邩, ړĂ邩, L̈ʒu, Ľ, L̃Xs[h(0`1), 蔻pIuWFNgz
--sJʒu, J_t
function camera:GetPosAt(inputFlag, moveFlag, charaPos, charaAng, charaSpeed, visualList)

	--J㉺L[̓͂󂯎
	local upFlag = (INPUT.UP == 1 or (INPUT.RIGHT_V == I.J_MIN and INPUT.PRE_RIGHT_V > I.J_MIN) )
	local downFlag = (INPUT.DOWN == 1 or (INPUT.RIGHT_V == I.J_MAX and INPUT.PRE_RIGHT_V < I.J_MAX) )

	--J̉̓͂󂯎
	local backFlag = (INPUT.HOME == 1)
	local leftFlag = (0 < INPUT.CCW or 0 < INPUT.RIGHT_H)
	local rightFlag = (0 < INPUT.CW or INPUT.RIGHT_H < 0)

	--͂𔽉fȂꍇ
	if inputFlag == false then
		upFlag    = false
		downFlag  = false
		backFlag  = false
		leftFlag  = false
		rightFlag = false
	end

	--JɈړƂ̏
	if upFlag and self.mHeightMin < self.mHeightNum then
		self.mHeightStart = self.mCount
		self.mHeightNum = self.mHeightNum - 1
		self.mHeightNext = 100 * self.mHeightNum + 100 + 6
		self.mHeightPos = self.mHeight
	end

	--JɈړƂ̏
	if downFlag and self.mHeightNum < self.mHeightMax then
		self.mHeightStart = self.mCount
		self.mHeightNum = self.mHeightNum + 1
		self.mHeightNext = 100 * self.mHeightNum + 100 + 6
		self.mHeightPos = self.mHeight
	end

	--z[L[͂ꂽ
	if backFlag then
	
		--px360xɕ␳
		self.mAngleY = TMP_ANGLE:Set(DEG(self.mAngleY) ):Revise():ToFloat()

		--px߂Ƃ납悤ɕ␳
		local angle = 0
		if charaAng < self.mAngleY then
			if 180 < self.mAngleY - charaAng then
				angle = (360 - self.mAngleY) + charaAng
			else
				angle = -1 * (self.mAngleY - charaAng)
			end
		else
			if 180 <= charaAng - self.mAngleY then
				angle = -1 * ( (360 - charaAng) + self.mAngleY)
			else
				angle = (charaAng - self.mAngleY)
			end
		end

		--덷lĈړ
		if angle < -1 or 1 < angle then
			self.mAngleYNext = angle * 2 --GetSmoothDiff̔Jn邽angle̓{
			self.mAngleYStart = self.mCount
			self.mBackState:Change(true) --JɉԂƂȂ
		end

	--L[͂ꂽ
	elseif leftFlag then
		self.mAngleYNext = (0 < INPUT.CCW and -20 or INPUT.RIGHT_H / I.J_MAX * -20)
		self.mAngleYStart = self.mCount

	--EL[͂ꂽ
	elseif rightFlag then
		self.mAngleYNext = (0 < INPUT.CW and 20 or INPUT.RIGHT_H / I.J_MAX * -20)
		self.mAngleYStart = self.mCount

	--LړĂ
	elseif moveFlag == true then

		--px360xɕ␳
		local charaCleanAng = TMP_ANGLE:Set(DEG(charaAng) ):Revise():ToFloat()
		local camAngY   = TMP_ANGLE:Set(DEG(self.mAngleY) ):Revise():ToFloat()

		--px߂Ƃ납悤ɕ␳
		local angle = 0
		local mag = 12 - charaSpeed * 7.5
		if charaCleanAng < camAngY then
			if 180 < camAngY - charaCleanAng then
				angle = ( (360 - camAngY) + charaCleanAng) / mag
			else
				angle = (-1 * (camAngY - charaCleanAng) ) / mag
			end
		else
			if 180 <= charaCleanAng - camAngY then
				angle = (-1 * ( (360 - charaCleanAng) + camAngY) ) / mag
			else
				angle = (charaCleanAng - camAngY) / mag
			end
		end

		--Ȃ悤ɂ鐧
		if 90 / mag < angle and angle < 180 / mag then
			angle = 180 / mag - angle
		end
		if -(180 / mag) <= angle and angle < -(90 / mag) then
			angle = -(180 / mag + angle)
		end

		--덷ƁAJɉ鏈ȂlĈړ
		if (angle < -1 or 1 < angle) and self.mBackState.mFlag == false then
			self.mAngleYNext = angle
			self.mAngleYStart = self.mCount
		end
	end

	--Y]pxݒ
	local angleYCount = self.mCount - self.mAngleYStart --Y]px̃JE^
	local countY = 26
	if angleYCount < (countY / 2 + 1) then
		self.mAngleY = self.mAngleY + GetSmoothDiff(self.mAngleYNext, countY, angleYCount + (countY / 2 + 1) )
	end

	--Jɉ鏈̏ԂǗ
	if countY <= self.mBackState.mCount then self.mBackState:Change(false) end
	self.mBackState:CountUp(1)

	--J̍ݒ
	local HeightCount = self.mCount - self.mHeightStart
	if HeightCount <= 14 and 14 < self.mCount then
		self.mHeight = self.mHeightPos + GetSmoothValue(self.mHeightNext-self.mHeightPos, 24, HeightCount + 14)
	end

	--J̒_ݒ
	TMP_VECTOR:Set(charaPos)
	TMP_VECTOR.y = TMP_VECTOR.y + 20.0 --
	self.mTempAt:Set(TMP_VECTOR)

	--J̍s쐬
	self.mRotate:RotationY(DEG_ANGLE(self.mAngleY) )
	self.mHeightTrans:Translation(0, self.mHeight, 0)
	self.mMatrix = self.mHeightTrans * self.mRollTrans * self.mRotate

	--Js񂩂J̈ʒuo
	self.mTempPosition.x = charaPos.x + self.mMatrix._41
	self.mTempPosition.y = charaPos.y + self.mMatrix._42
	self.mTempPosition.z = charaPos.z + self.mMatrix._43

	--JƔwi̓蔻
	self:ToMap(400, 650, 400, charaPos, visualList)

	--JʒuƃJ_Ԃ
	return self.mTempPosition, self.mTempAt
end

--JƃIuWFNgƂ̓蔻y蔻͈͂AABB̕, , s, L̈ʒu, oXgz
function camera:ToMap(width, height, depth, charaPos, visualList)

	--ꎞϐ
	local direction      = TMP_VECTOR
	local firstDirection = TMP_VECTOR_A
	local normal         = TMP_VECTOR_B
	local distance       = -1.0
	local cosTheta       = 0
	local tipOfDir       = 0
	local shortest       = 1000000 --łẐ\
	local min            = TMP_VECTOR_C
	local max            = TMP_VECTOR_D

	--LAABB߂
	GetMinMax(charaPos, width, height, depth, min, max)

	--ŏ̃CxNg߂
	firstDirection:Set(self.mTempPosition - self.mTempAt)

	--}bṽIuWFNg
	for key, value in pairs(visualList) do

		--AABBő܂Ȕ
		if AABBJudgment(value:GetMesh(), value:GetMatrix(), min, max) then

			--
			direction:Set(firstDirection)

			--C
			local distance = RayJudgment(value:GetMesh(), value:GetMatrix(), self.mTempAt, direction:GetNormal(), normal, nil)

			--@ƃCxNg̓ς߂
			local cosTheta = normal:Dot(direction:GetNormal() * -1)

			--+̈ʒuNCxNg̒߂
			local tipOfDir = 1.0 * (1.0 / cosTheta)
			if tipOfDir < 0 then tipOfDir = -tipOfDir end

			--߂荞łꍇA+̈ʒuɈړ
			if 0 <= distance and distance - tipOfDir < direction:GetLength() - tipOfDir then

				--łZꍇɔf
				if distance < shortest then
					direction:Stretch(distance - tipOfDir)
					self.mTempPosition:Set(self.mTempAt + direction)
					shortest = distance
				end
			end
		end
	end
end

--JړyړʒuŏIn_, ړ_ŏIn_, JEgňړ邩, ݂̃JEgz
function camera:Move(posMax, atMax, max, count)

	--ړ߂
	self.mStartPos:Set(posMax - self.mTempPosition)
	self.mStartAt:Set(atMax - self.mTempAt)

	--J݈̌ʒu߂
	self.mPosition:Set(self.mTempPosition + GetSmoothValue(self.mStartPos, max, count) )

	--J̌ݒ_߂
	self.mAt:Set(self.mTempAt + GetSmoothValue(self.mStartAt, max, count) )
end

--Jړ錾yړJntOz
function camera:EnableMoving(flag)
	self.mMoveState:Change(flag)
end