
--XNvg[h
--_G.OnReload = function() print("class _G.OnReload") end


--SCX^XmQƃe[u
local gAllInstance = {}
setmetatable(gAllInstance, {__mode = "kv"})

--L̎擾
function GetAllInstance() return gAllInstance end


--NX̍쐬yNX, pNX = nil, [h^Cv = nilz
function Class(className, superClass, reloadType)

	--ftHg̃NX[h^Cvݒ
	reloadType = reloadType or RELOADTYPE_NEWMEMBER

	--NX̐ÓIoe[uw肵ăNX쐬֐R[
    return function(classData) CreateClass(className, superClass, classData, reloadType) end
end


--NX[h^CvFNX̐ÓIoɑ΂ă[hsȂ
function RELOADTYPE_NORELOAD(class, superClass, classData)
end

--NX[h^CvFNX̐ÓIo
function RELOADTYPE_INITIALIZE(class, superClass, classData)
	for t, i in pairs(classData) do class[t] = i end --}Ă̐ÓIo
end

--NX[h^CvFVÓIoǉ
function RELOADTYPE_NEWMEMBER(class, superClass, classData)
	for t, i in pairs(classData) do
		if rawget(class, t) == nil then class[t] = i end --L[`ĂȂΒǉ
	end
end


--CX^X̃NXe[u擾
function GetClass(t)
	local mt = getmetatable(t)
	if type(mt) == "table" then return rawget(mt, "__index") end
	return nil
end

--CX^X̃NX擾
function GetClassName(t)
	local class = GetClass(t)
	if class then return rawget(class, "name") end
	return nil
end

--NX̃CX^Xۂ
function IsClassInstance(t) return (GetClass(t) and true or false) end


--CX^X̍쐬󋵂o
function PrintAllInstance()
	print("*** LuaNX쐬 ***")
	local classList = {}

	--}ẴCX^XgpĂNXo
	local num = 0
	for class, i in pairs(gAllInstance) do
		if classList[class.name] == nil then classList[class.name] = 0 end
		classList[class.name] = classList[class.name] + 1 --CX^XL^
		num = num + 1
	end

	if num == 0 then print("*** NX̃CX^X쐬Ă܂ ***") end
	for name, i in pairs(classList) do print(" \""..name.."\", "..i.."") end
end

--NX̍쐬iKclass֐ʂăR[j
function CreateClass(className, superClass, classData, reloadType)

	--NXϐe[ułȂ
	if type(classData) ~= "table" then print("*** NX̐ÓIϐ̓e[uō쐬Ă ***") end

	-- O[oɊɃNX݂΂g
	local class = rawget(_G, className)

	--NXɒ`Ă
	if class then
		reloadType(class, superClass, classData) --[h^Cvɍ킹֐R[

	--NX`ĂȂ
	else
		class = classData
		class.constructor = function(self) end --ftHgRXgN^
		_G[className] = class --NX̐ÓIϐe[uNX̃O[oϐƂ
	end

	--pNX̎w肪
	if superClass then
		class.super = superClass --superoɌpNXݒ

		--p^e[uƂċ@\Ăꍇ
		if rawget(superClass, "__index") == superClass then setmetatable(class, superClass)

		--pNXCfbNXɎ^e[uZbg
		else setmetatable(class, {__index = superClass} ) end
	end

	--CX^X쐬bsOfactoryo֐쐬
	class.factory = function (self, ...)
		local t = {}           --CX^XƂȂe[u쐬
		setmetatable(t, self)  --NXCX^X̃^e[uɃZbg
		gAllInstance[t] = true --CX^X݂̑L^
		t:constructor(...)     --RXgN^R[
		return t
	end
	
	--nameoɖOݒ
	class.name = className

	--^e[uƂċ@\
	class.__index = class
end


--SNX̃CX^XOnReloads
function CallOnReloadOfClassInstance()
	for t, i in pairs(gAllInstance) do
		if rawget(GetClass(t), "OnReload") then t:OnReload() end
	end
end

--e[u̍폜tÔ郁o폜ye[u, o̍폜tOz
function FillTable(t, flag)
	local i = 1
	while i <= #t do
		if (t[i] ~= nil) and (t[i][flag] == true) then
			t[i]:destructor()
			table.remove(t, i)
		else
			i = i + 1
		end
	end
end

--e[u̍폜tO@Ɋւ炸폜
function DeleteTable(t)
	local i = 1
	while i <= #t do
		if (t[i] ~= nil) then
			t[i]:destructor()
			table.remove(t, i)
		else
			i = i + 1
		end
	end
end