
local gLoadStyle = ... --󂯎

local gFile = {}           --[hΏۃXNvgt@Ce[u
local gReloadFunction = {} --[hXV֐e[u
local gOriginalPath = {}   --[hXV֐̌t@CiG[o͗pj
local gReleadFlag = false  --[h[h

--LuãoCh@\
_G.LUA = LuaN.LUA()

--[h
if gLoadStyle == "init" then
	gFile = {
		"script\\system.lua",
		"script\\input.lua",
		"key_config.txt",
		"script\\class.lua",
		"script\\state.lua",
		"script\\fade.lua",
		"script\\particle.lua",
		"script\\spiral.lua",
		"script\\camera.lua",
		"script\\collision.lua",
		"script\\scene.lua",
		"script\\title_scene.lua",
		"script\\map_scene.lua",
		"script\\stage00_scene.lua",
		"script\\stage01_scene.lua",
		"script\\stage02_scene.lua",
		"script\\chara.lua",
		"script\\player_chara.lua",
		"script\\main.lua",
	}
	gReloadFlag = false --[h

--ݒEVXẽXNvĝ݃[h
elseif gLoadStyle == "setting" then
	gFile = {
		"script\\system.lua",
	}
	gReloadFlag = false --[h

--V[̃XNvĝ݃[h
elseif gLoadStyle == "scene" then
	gFile = {
		"script\\scene.lua",
		"script\\title_scene.lua",
		"script\\map_scene.lua",
		"script\\stage00_scene.lua",
		"script\\stage01_scene.lua",
		"script\\stage02_scene.lua",
	}
	gReloadFlag = true --[h

--L̃XNvĝ݃[h
elseif gLoadStyle == "chara" then
	gFile = {
		"script\\chara.lua",
		"script\\player_chara.lua",
	}
	gReloadFlag = true --[h

--}ẴXNvg[h
elseif gLoadStyle == "all" then

	--pcallŃXNvgI֐bsOăR[
	local result, errorMessage = pcall(function() ScriptExit() end)
	if result == false then print("*** IɎs܂ ***\n ڍׁF"..errorMessage) end

	gFile = {
		"script\\system.lua",
		"script\\input.lua",
		"key_config.txt",
		"script\\class.lua",
		"script\\state.lua",
		"script\\fade.lua",
		"script\\particle.lua",
		"script\\spiral.lua",
		"script\\camera.lua",
		"script\\collision.lua",
		"script\\scene.lua",
		"script\\title_scene.lua",
		"script\\map_scene.lua",
		"script\\stage00_scene.lua",
		"script\\stage01_scene.lua",
		"script\\stage02_scene.lua",
		"script\\chara.lua",
		"script\\player_chara.lua",
		"script\\main.lua",
	}
	gReloadFlag = true --[h

	--֐[hXV֐̓ɓo^
	table.insert(gReloadFunction, function() ScriptInitialize() return true end)

--sȈ
else
	return false, "*** <"..gLoadStyle.."> ̈ɊY郍[hX^C͂܂ ***"
end

--OnReload
if rawget(_G, "OnReload") ~= nil then rawset(_G, "OnReload", nil) end

--t@C[h
print("*** XNvg̃[hJn ["..gLoadStyle.."] ***")
for i, path in ipairs(gFile) do
	
	--t@Cǂݍ
	local result = LUA:RunLuaFile(path)
	local errorMessage = LUA:GetLuaErrorMessage()
	if not result then
		return false, " XNvg<"..path..">̃[hɎs܂B\n\n"..(errorMessage or "s̃G[łI\n")
	end

	--OnReloadEĂĕۊ
	if rawget(_G, "OnReload") ~= nil then
		table.insert(gReloadFunction, rawget(_G, "OnReload") )
		gOriginalPath[rawget(_G, "OnReload")] = path --t@Cۊ
		rawset(_G, "OnReload", nil)
	end

	print(" XNvg<"..path..">̃[h܂B")
end

--[h֐R[
if gReloadFlag then

	print("*** [hXV֐s܂ ***")

	--eXNvgt@C̃[hXV֐R[
	for i, func in ipairs(gReloadFunction) do
		local result, errorMessage = func() --e[uR[
		if result == false then
			return false, " XNvg<"..gOriginalPath[func]..">̃[hXV֐̎sɎs܂B\n\n"..errorMessage
		end
	end

	--NX̃CX^XOnReload()R[
	CallOnReloadOfClassInstance()

end

--[h@\̏ڍׂ\
print([[*** R\[ؑցE[hL[ڍ ***]])
print([[ [1]L[FR\[Wo̓[hɐ؂ւB]])
print([[ [2]L[FR\[fobOo̓[hɐ؂ւB]])
print([[ [3]L[FWo͂LuãNX쐬󋵂\B]])
print(" [8]L[FL̃XNvg[hB")
print(" [9]L[FV[̃XNvg[hB")
print(" [0]L[F}ẴXNvg[hB")

--
return true
