
--XNvg[h
--_G.OnReload = function() print("particle _G.OnReload") end

--p[eBNꗱ\NX
Class("particle")({

	--ʒu
	mBasePosition = Vector3C(),
})

--RXgN^
function particle:constructor(name)
	
	--oϐ
	self.mRendering   = RENDERER:CreateBillboard(TPath(name) ) --r{[h
	self.mRunType     = "empty"                                --s֐^Cv
	self.mCount       = 0                                      --JE^
	self.mPreMatrix   = MatrixC()                              --ŏɌvZsi]Ɗgk̂݁j
	self.mTransMatrix = MatrixC()                              --ړs
end

--fXgN^iOR[j
function particle:destructor()

	--r{[h
	RENDERER:Erase(self.mRendering)
end

--XV
function particle:Run(eye, at, up)

	--^Cvɉs֐𓮂
	self[self.mRunType](self)

	--r{[h̍s쐬ĕϊ
	self.mRendering:SetMatrix(self.mPreMatrix, self.mTransMatrix, eye, at, up)

	--JEgAbv
	self.mCount = self.mCount + 1
end

--p[eBN쐬^CvFʂ̓y
--yۑe[u, ʒu, TCY, őJEg, gk, Yړʁz
particle.DirtyDust = function(t, position, scale, max, plusScale, plusY)

	--ỷ摜_Ő؂ւ
	local graph = "dirt_"..rand.range(0, 4)

	--p[eBN쐬
	local par = particle:factory(graph)

	--oݒ
	par.mRunType    = "large_dust"
	par.mPosition   = Vector3C(position)
	par.mScale      = scale
	par.mMaxCount   = max
	par.mPlusScale  = plusScale
	par.mPlusY      = plusY

	--ʒu쐬
	par.mPosition.x = par.mPosition.x + rand.s_range(0, 1000) * 0.003
	par.mPosition.y = par.mPosition.y + rand.s_range(0, 1000) * 0.003
	par.mPosition.z = par.mPosition.z + rand.s_range(0, 1000) * 0.003

	--e[uɓo^
	table.insert(t, par)
end

--p[eBN쐬^CvFR肾ꂽy
--yۑe[u, ʒu, 0~1̔fx, TCY, gk, Yړʁz
particle.KickDirtyDust = function(t, position, unit, scale, plusScale, plusY)

	--ỷ摜_Ő؂ւ
	local graph = "dirt_"..rand.range(0, 4)

	--fxőJEgZo
	local max = 0.5 < unit and unit * 30 or 0

	--p[eBN쐬
	local par = particle:factory(graph)

	--oݒ
	par.mRunType    = "large_dust"
	par.mPosition   = Vector3C(position)
	par.mScale      = scale
	par.mMaxCount   = max
	par.mPlusScale  = plusScale
	par.mPlusY      = plusY

	--ʒu쐬
	par.mPosition.x = par.mPosition.x + rand.s_range(0, 1000) * 0.005
	par.mPosition.y = par.mPosition.y - 12
	par.mPosition.z = par.mPosition.z + rand.s_range(0, 1000) * 0.005

	--e[uɓo^
	table.insert(t, par)
end

--p[eBN쐬^CvFLy
--yۑe[u, ʒu, L鎞̓y̐, TCY, őJEg, gkʁz
particle.SpreadDirtyDust = function(t, position, num, scale, max, plusScale)

	--[Jϐ錾
	local dirtPos    = TMP_VECTOR --y̔ʒu
	local dirtMatrix = TMP_MATRIX --ÿړs

	--nʂɂꍇ̓yo
	for i = 1, num do

		--W쐬
		dirtPos:Set(0, -12, rand.range(1, 3) )
		dirtMatrix:RotationY(DEG_ANGLE(i * (360 / num) ) )
		dirtPos:TransformCoord(dirtMatrix)
		dirtPos:Set(position + dirtPos)

		--ỷ摜_Ő؂ւ
		local graph = "dirt_"..rand.range(0, 4)

		--p[eBN쐬
		local par = particle:factory(graph)

		--oݒ
		par.mRunType    = "side_dust"
		par.mPosition   = Vector3C(dirtPos)
		par.mAngle      = 0
		par.mScale      = scale
		par.mMaxCount   = max
		par.mPlusScale  = plusScale
		par.mPlusAngle  = i * (360 / num)

		--e[uɓo^
		table.insert(t, par)
	end
end

--p[eBN쐬^CvFSPĂ
--yۑe[u, ʒu, px, TCY, őJEg, ]px, gkʁz
particle.SpreadLight = function(t, position, angle, scale, max, plusAngle, plusScale)

	--p[eBN쐬
	local par = particle:factory("neji_light")

	--oݒ
	par.mRunType   = "spread_light"
	par.mPosition  = Vector3C(position)
	par.mAngle     = angle
	par.mScale     = scale
	par.mMaxCount  = max
	par.mPlusAngle = plusAngle
	par.mPlusScale = plusScale

	--Z
	par.mRendering:AdditiveBlending(true)

	--e[uɓo^
	table.insert(t, par)
end

--p[eBN쐬^CvFH΂܂
--yۑe[u, ʒu, px, TCY, őJEg, ]px, gkʁz
particle.Feather = function(t, position, angle, scale, max, plusAngle, plusScale)

	--p[eBN쐬
	local par = particle:factory("feather")

	--oݒ
	par.mRunType   = "feather"
	par.mPosition  = Vector3C(position)
	par.mAngle     = angle
	par.mScale     = scale
	par.mMaxCount  = max
	par.mPlusAngle = plusAngle
	par.mPlusScale = plusScale

	--W쐬
	par.mPosition.x = par.mPosition.x + rand.s_range(0, 20)
	par.mPosition.y = par.mPosition.y + rand.s_range(0, 20)
	par.mPosition.z = par.mPosition.z + rand.s_range(0, 20)

	--e[uɓo^
	table.insert(t, par)
end

--p[eBN쐬^CvF͋ԂGtFNg
--yۑe[u, ʒu, TCY, TCYY, őJEg, gk, Ygkʁz
particle.Power = function(t, position, scale, scaleY, max, plusScale, plusScaleY)

	--p[eBN쐬
	local par = particle:factory("power")

	--oݒ
	par.mRunType    = "power"
	par.mPosition   = Vector3C()
	par.mScale      = scale
	par.mScaleY     = scaleY
	par.mMaxCount   = max
	par.mPlusScale  = plusScale
	par.mPlusScaleY = plusScaleY

	--W쐬
	par.mDiffPosition = Vector3C(rand.s_range(0, 15), -20, rand.s_range(0, 15) )

	--e[uɓo^
	table.insert(t, par)
end

--s֐^CvFȂ
function particle:empty()

	--
	self.mDeleteFlag = true
end

--s֐^CvF̍̓
function particle:side_dust()

	--wJEg܂ŎwʊgkAAt@lĂ
	if 0 <= self.mCount and self.mCount < self.mMaxCount then
		self.mScale = self.mScale + self.mPlusScale
		self.mRendering:SetAlpha(255 - (self.mCount * (255 / self.mMaxCount) ) )
	end

	--Ȃwpx̕ֈړĂ
	local attenuation = (self.mMaxCount - self.mCount) / self.mMaxCount * 0.1
	local dirVec      = TMP_VECTOR:Set(0, 0.2 - attenuation, 0.6 - (attenuation * 6) )
	local rotateY     = TMP_MATRIX:RotationY(DEG_ANGLE(self.mPlusAngle) )
	dirVec:TransformCoord(rotateY)
	self.mPosition = self.mPosition + dirVec

	--sɐݒ
	local scale    = TMP_MATRIX_A:Scaling(self.mScale)
	local rotation = TMP_MATRIX_B:RotationZ(DEG_ANGLE(self.mAngle) )
	self.mPreMatrix:Set(scale * rotation)
	self.mTransMatrix:Translation(self.mPosition)

	--JEg߂Ə
	if self.mMaxCount <= self.mCount then self.mDeleteFlag = true end
end

--s֐^CvF傫̓
function particle:large_dust()

	--wJEg܂ŎwʊgkAAt@lĂ
	if 0 <= self.mCount and self.mCount < self.mMaxCount then
		self.mScale = self.mScale + self.mPlusScale
		self.mRendering:SetAlpha(128 - (self.mCount * (128 / self.mMaxCount) ) )
	end

	--YɈړ
	self.mPosition = self.mPosition + TMP_VECTOR:Set(0, self.mPlusY, 0)

	--sɐݒ
	local scale = TMP_MATRIX:Scaling(self.mScale)
	self.mPreMatrix:Set(scale)
	self.mTransMatrix:Translation(self.mPosition)

	--JEg߂Ə
	if self.mMaxCount <= self.mCount then self.mDeleteFlag = true end
end

--s֐^CvF]Ȃg傷铮
function particle:spread_light()

	--wJEg܂ŏ
	if 0 <= self.mCount and self.mCount < self.mMaxCount then

		--gkE]
		self.mScale = self.mScale + self.mPlusScale
		self.mAngle = self.mAngle + self.mPlusAngle

		--őJEg4%6%̃JEg`
		local fourPercent = self.mMaxCount * 0.4
		local sixPercent  = self.mMaxCount * 0.6

		--iXAt@lオAiXĂ
		if self.mCount <= fourPercent then
			self.mRendering:SetAlpha(self.mCount * (100 / fourPercent) )
		elseif self.mCount <= sixPercent then
			self.mRendering:SetAlpha(100)
		elseif self.mCount <= self.mMaxCount then
			self.mRendering:SetAlpha(100 - ( (self.mCount - sixPercent) * (100 / fourPercent) ) )
		else
			self.mRendering:SetAlpha(0)
		end
	end

	--sɐݒ
	local scale    = TMP_MATRIX_A:Scaling(self.mScale)
	local rotation = TMP_MATRIX_B:RotationZ(DEG_ANGLE(self.mAngle) )
	self.mPreMatrix:Set(scale * rotation)
	self.mTransMatrix:Translation(self.mPosition)

	--JEg߂Ə
	if self.mMaxCount <= self.mCount then self.mDeleteFlag = true end
end

--s֐^CvFU΂GtFNg̓
function particle:feather()

	--wJEg܂ŏ
	if 0 <= self.mCount and self.mCount < self.mMaxCount then

		--gkE]Eւ̈ړ
		self.mScale = self.mScale + self.mPlusScale
		self.mAngle = self.mAngle + self.mPlusAngle
		self.mPosition = self.mPosition + TMP_VECTOR:Set(0, 1.0, 0)

		--őJEg2%4%6%̃JEg`
		local twoPercent  = self.mMaxCount * 0.2
		local fourPercent = self.mMaxCount * 0.4
		local sixPercent  = self.mMaxCount * 0.6

		--iXAt@lオAiXĂ
		if self.mCount <= twoPercent then
			self.mRendering:SetAlpha(self.mCount * (255 / twoPercent) )
		elseif self.mCount <= sixPercent then
			self.mRendering:SetAlpha(255)
		elseif self.mCount <= self.mMaxCount then
			self.mRendering:SetAlpha(255 - ( (self.mCount - sixPercent) * (255 / fourPercent) ) )
		else
			self.mRendering:SetAlpha(0)
		end
	end

	--sɐݒ
	local scale    = TMP_MATRIX_A:Scaling(self.mScale)
	local rotation = TMP_MATRIX_B:RotationZ(DEG_ANGLE(self.mAngle) )
	self.mPreMatrix:Set(scale * rotation)
	self.mTransMatrix:Translation(self.mPosition)

	--JEg߂Ə
	if self.mMaxCount <= self.mCount then self.mDeleteFlag = true end
end

--s֐^CvFLяオGtFNg̓
function particle:power()

	--wJEg܂ŏ
	if 0 <= self.mCount and self.mCount < self.mMaxCount then

		--gkEړ
		self.mScale = self.mScale + self.mPlusScale
		self.mScaleY = self.mScaleY + self.mPlusScaleY
		self.mDiffPosition.y = self.mDiffPosition.y + 1.0
		self.mPosition:Set(particle.mBasePosition + self.mDiffPosition)

		--őJEg2%4%6%̃JEg`
		local twoPercent  = self.mMaxCount * 0.2
		local fourPercent = self.mMaxCount * 0.4
		local sixPercent  = self.mMaxCount * 0.6

		--iXAt@lオAiXĂ
		if self.mCount <= twoPercent then
			self.mRendering:SetAlpha(self.mCount * (255 / twoPercent) )
		elseif self.mCount <= sixPercent then
			self.mRendering:SetAlpha(255)
		elseif self.mCount <= self.mMaxCount then
			self.mRendering:SetAlpha(255 - ( (self.mCount - sixPercent) * (255 / fourPercent) ) )
		else
			self.mRendering:SetAlpha(0)
		end
	end

	--sɐݒ
	local scaleY = TMP_MATRIX:Scaling(1, self.mScaleY, 1)
	local scale  = TMP_MATRIX_A:Scaling(self.mScale)
	self.mPreMatrix:Set(scaleY * scale)
	self.mTransMatrix:Translation(self.mPosition)

	--JEg߂Ə
	if self.mMaxCount <= self.mCount then self.mDeleteFlag = true end
end