
--XNvg[h
--_G.OnReload = function() print("player_chara _G.OnReload") end

--vC[NX
Class("player_chara", chara)({})

--RXgN^
function player_chara:constructor(...)
	self.super:constructor(...)
	
	--oϐ
	self.mCount = 0                            --CJE^
	self.mSpeed = 0.5                          --vC[̈ړXs[h
	self.mSpeedMax = 2.5                       --vC[̈ړXs[hől
	self.mMoveFlag = false                     --ړĂ邩
	self.mAngle = 0                            --ľ\px
	self.mGuideAngle = 0                       --lׂpx
	self.mAngleFlag = false                    --
	self.mVelocity = Vector3C()                --xxNg
	self.mPreVelocity = Vector3C()             --ȎxxNg
	self.mDirection = Vector3C()               --vC[̌Ă
	self.mPosition = Vector3C()                --ʒuxNg
	self.mTrans = MatrixC()                    --ړs
	self.mScale = MatrixC()                    --gks
	self.mRotate = MatrixC()                   --Y]s
	self.mMatrix = MatrixC()                   --vZs
	self.mCamForeVector = Vector3C()           --J̑OxNg
	self.mGravity = -5                         --d
	self.mJumpStartFlag = false                --WvJn
	self.mJumpContinueFlag = false             --WvĂ邩
	self.mJumpCount = 0                        --WvJEg
	self.mJumpVelocity = Vector3C()            --WvJn̑xxNg
	self.mJumpAddVelocity = Vector3C()         --WvɉZxNg
	self.mOnLandFlag = false                   --nʂɗĂ邩
	self.mPreOnLandFlag = false                --OnʂɗĂ
	self.mPushPullState = state:factory()      --
	self.mHoldState = state:factory()          --ǂɌĒtĂ邩
	self.mRightLegSoundState = state:factory() --Eʔ
	self.mLeftLegSoundState = state:factory()  --ʔ

	--oϐl
	self.mScale:Scaling(10)
	self.mPosition:Set(0, 12, 0)
	self.mCamForeVector:Set(Z_AXIS)

	--vC[̊ep[c쐬
	self.mPartsList = {
		mAntennaL  = RENDERER:CreateModel(XPath("player_antenna2") ),
		mAntennaR  = RENDERER:CreateModel(XPath("player_antenna2") ),
		mArmL      = RENDERER:CreateModel(XPath("player_arm_n") ),
		mArmR      = RENDERER:CreateModel(XPath("player_arm_n") ),
		mBody      = RENDERER:CreateModel(XPath("player_body_n") ),
		mHead      = RENDERER:CreateModel(XPath("player_head_n") ),
		mLegL      = RENDERER:CreateModel(XPath("player_leg_n") ),
		mLegR      = RENDERER:CreateModel(XPath("player_leg_n") ),
		mNeji      = RENDERER:CreateModel(XPath("player_neji") ),
	}

	--vC[̊ep[c𒼐ڃANZXł悤ɍ쐬
	for key, resource in pairs(self.mPartsList) do
		self[key] = resource
	end

	--`IuWFNgɉet
	--for key, model in pairs(self.mPartsList) do
	--	model:SetShader(SHADOWMAP)
	--end

	--vC[̃Aj[V̕ϐ
	self.mAnimeState = {
		stand = state:factory(), --
		walk = state:factory(),  --s
		jump = state:factory(),  --Wv
		fall = state:factory(),  --
		push = state:factory(),  --
		pull = state:factory(),  --
		hold = state:factory(),  --
	}
end

--s֐
function player_chara:Run()

	--Wv́AWv̈ړxNgZ
	if self.mJumpStartFlag == true then
		self.mJumpVelocity:Set(self.mJumpVelocity + self.mJumpAddVelocity)
		self.mVelocity:Set(self.mJumpVelocity)
	end

	--Xs[h͕ۂ
	if self.mSpeed == 0 then self.mSpeed = 0.01 end

	--xxNg쐬
	self.mVelocity:Stretch(self.mSpeed)

	--ړĂȂ
	if self.mVelocity.x == 0 and self.mVelocity.y == 0 and self.mVelocity.z == 0 then
		self.mMoveFlag = false
	else
		self.mMoveFlag = true
	end

	--d͂vZ
	self.mGravity = self.mGravity - 0.2
	if self.mGravity < -7 then self.mGravity = -7 end -- -7艺ɂ͍sȂ
	if self.mOnLandFlag == true and self.mJumpStartFlag == false then
		self.mGravity = -3.5 --nʂɂĂƂ
	end
	if self.mOnLandFlag == false and self.mPreOnLandFlag == true and self.mJumpStartFlag == false then
		self.mGravity = 0 --nʂ痣Ă鎞
	end
	self.mPosition:Set(self.mPosition + (Y_AXIS * self.mGravity) )

	--~iړ͂ȂAOړĂAXs[hۂĂꍇj
	local preMoveFlag = (self.mPreVelocity.x ~= 0 or self.mPreVelocity.y ~= 0 or self.mPreVelocity.z ~= 0)
	if self.mMoveFlag == false and preMoveFlag and 0.5 < self.mSpeed then
		self.mVelocity:Set(self.mPreVelocity)
		self.mVelocity:Stretch(self.mSpeed)
	end

	--xxNg𔽉f
	self.mPosition:Set(self.mPosition + self.mVelocity)

	--ړs쐬
	self.mTrans:Translation(self.mPosition)

	--xvZ
	self:CalcSpeed()

	--K؂ȕ֌
	self:Turn()

	--ŏIIȍsZo
	self.mMatrix:Set(self.mScale * self.mRotate * self.mTrans)

	--xxNgۑ
	self.mPreVelocity:Set(self.mVelocity)

	--ۑ
	if self.mMoveFlag == true then
		self.mDirection:Set(self.mVelocity)
		self.mDirection:Normalize()
	end

	--xxNgNA
	self.mVelocity:Set(0, 0, 0)

	--Aj[VXV
	self:RunAnimation()

	--WvJn̎Ԃv
	if self.mJumpStartFlag then self.mJumpCount = self.mJumpCount + 1 end

	--JEgAbv
	self.mCount = self.mCount + 1


	--炷
	if self.mPreOnLandFlag == false and self.mOnLandFlag == true then

		--n炷
		WAVESOUND:Play(WPath("kick_"..rand.range(0, 4) ), self.mPosition, self.mVelocity, 5, 200)
		WAVESOUND:Play(WPath("kick_"..rand.range(0, 4) ), self.mPosition, self.mVelocity, 5, 200)
	end

	return nil
end

--fXgN^iOR[j
function player_chara:destructor()

	--f̉
	RENDERER:Erase(self.mAntennaL)
	RENDERER:Erase(self.mAntennaR)
	RENDERER:Erase(self.mArmL)
	RENDERER:Erase(self.mArmR)
	RENDERER:Erase(self.mBody)
	RENDERER:Erase(self.mHead)
	RENDERER:Erase(self.mLegL)
	RENDERER:Erase(self.mLegR)
	RENDERER:Erase(self.mNeji)
end

--[h֐
function player_chara:OnReload()
end

--lWؑցylW̃^Cvz
function player_chara:ChangeNeji(nejiType)

	--ۂ̃\[Xƍ킹
	if nejiType == "normal" then nejiType = "neji" end
	self.mNeji:SetMesh(XFILE:GetXFile(XPath("player_"..nejiType) ) )

	--̐ݒύX
	self.mPushPullState:Change(false)
	self.mJumpStartFlag = false
end

--Aj[Vݒyݒ肷Aj[Vz
function player_chara:SetAnimation(animeType)

	--w肳ꂽ̂LɂAc𖳌ɂ
	for key, v in pairs(self.mAnimeState) do
		if key == animeType then v:Change(true) else v:Change(false) end
	end
end

--ړxύXyړx0~1z
function player_chara:ChangeSpeed(mag)
	self.mSpeedMax = 2.5 * mag
end

--ړx(0.0 ` 1.0)Ŏ擾
function player_chara:GetUnitSpeed()
	return self.mSpeed / 2.5
end

--wֈړyOxNg, -1.0`1.0Xړ, -1.0`1.0Yړʁz
function player_chara:MoveDirection(vector, x, y)

	local rotateY = TMP_MATRIX --Y]s

	--Oƃ}CiXZƂ̊px擾
	local angle = vector:GetAngle(Z_AXIS * -1):ToDeg() * (0 <= vector.x and -1 or 1)

	--ẌړʂŸړʂXZɕϊKxNg쐬
	self.mVelocity:Set(x, 0, y):Normalize()

	--̕Ɍ
	rotateY:RotationY(DEG_ANGLE(-1 * angle) )
	self.mVelocity:TransformCoord(rotateY)
	self.mVelocity.x = self.mVelocity.x * -1
	self.mVelocity.y = self.mVelocity.y * -1
end

--WvwֈړyOxNg, -1.0`1.0Xړ, -1.0`1.0Yړʁz
function player_chara:JumpMoveDirection(vector, x, y)

	local rotateY = TMP_MATRIX --Y]s

	--Oƃ}CiXZƂ̊px擾
	local angle = vector:GetAngle(Z_AXIS * -1):ToDeg() * (0 <= vector.x and -1 or 1)

	--ẌړʂŸړʂXZɕϊKxNg쐬
	self.mJumpAddVelocity:Set(x, 0, y):Normalize()

	--̕Ɍ
	rotateY:RotationY(DEG_ANGLE(-1 * angle) )
	self.mJumpAddVelocity:TransformCoord(rotateY)
	self.mJumpAddVelocity.x = self.mJumpAddVelocity.x * -1
	self.mJumpAddVelocity.y = self.mJumpAddVelocity.y * -1
end

--~
function player_chara:Stop()
	self.mPreVelocity:Set(0, 0, 0)
	self.mVelocity:Set(0, 0, 0)
	self.mJumpVelocity:Set(0, 0, 0)
	self.mSpeed = 0.5
	self.mMoveFlag = false
	self.mJumpStartFlag = false
end

--K؂ȕ֌
function player_chara:Turn()

	--lׂpx
	local angle = self.mGuideAngle

	--ړύXȂĂꍇ
	if self.mMoveFlag == true and self.mAngleFlag == true then

		--px쐬
		TMP_ANGLE:Set(DEG(self.mVelocity:GetAngle(Z_AXIS * -1):ToDeg() * (0 <= self.mVelocity.x and -1 or 1) ) )
		angle = (math.floor(TMP_ANGLE:ToDeg() ) + (TMP_ANGLE:ToDeg() < 0 and 360 or 0) )
	end

	--px␳
	if angle < 0 then angle = angle + 360 end
	if 360 < angle then angle = angle - 360 end
	if self.mAngle < 0 then self.mAngle = self.mAngle + 360 end
	if 360 < self.mAngle then self.mAngle = self.mAngle - 360 end

	--ύX`FbN
	if angle ~= self.mAngle then
		self.mAngleFlag = false
	end

	--ύXꍇ
	if self.mAngleFlag == false then

		--߂pxւƕ]
		if self.mAngle < 90 and 270 <= angle then
			self.mAngle = self.mAngle - 12
		elseif angle < 90 and 270 <= self.mAngle then
			self.mAngle = self.mAngle + 12
		elseif self.mAngle < angle then
			self.mAngle = self.mAngle + 12
			if angle < self.mAngle then self.mAngle = angle end
		elseif angle < self.mAngle then
			self.mAngle = self.mAngle - 12
			if self.mAngle < angle then self.mAngle = angle end
		end
	end

	--傤ǓB
	if angle == self.mAngle then self.mAngleFlag = true end

	--݂̎wjێ
	self.mGuideAngle = angle

	--݂̊px]s쐬
	self.mRotate:RotationY(DEG_ANGLE(self.mAngle) )
end

--Xs[hvZ
function player_chara:CalcSpeed()

	--ړ̓Xs[hf
	if self.mMoveFlag == true then
		if self.mSpeed < self.mSpeedMax then self.mSpeed = self.mSpeed + 0.05 end
		if self.mSpeedMax <= self.mSpeed then self.mSpeed = self.mSpeedMax end

	--~͊𔽉f
	else
		if 0.5 < self.mSpeed then self.mSpeed = self.mSpeed - 0.20 end
	end
end

--Aj[V̐ݒ聕XV֐
function player_chara:RunAnimation()

	--Aj[Vݒ
	local animeSpeed = 2.0
	local jumpCount = self.mAnimeState["jump"].mCount
	local pushCount = self.mAnimeState["push"].mCount
	local holdCount = self.mAnimeState["hold"].mCount

	--ړWvł͂ȂƂ͕s
	if self.mMoveFlag == true and self.mJumpStartFlag == false then
		local speed = self.mSpeed + 1.0 < 2.0 and self.mSpeed + 1.0 or 2.0
		if self.mPushPullState.mFlag == false and self.mHoldState.mFlag == false then
			animeSpeed = speed + 1.0
			self:SetAnimation("walk")

		--[V
		elseif 2 < self.mPushPullState.mCount then
			self:SetAnimation("push")
			animeSpeed = speed
		end

	--Wvł΃WvAWvĂ玞ԂoƗ
	elseif self.mJumpStartFlag == true then
		if self.mJumpCount < 40 then
			self:SetAnimation("jump")
		else
			self:SetAnimation("fall")
			animeSpeed = 3.0
		end

	--nʂɂĂƂ͋NAnʂɂĂȂƂ͗
	else
		if self.mOnLandFlag == true then

			--[V
			if (self.mPushPullState.mFlag == true or self.mHoldState.mFlag == true) then

				if self.mHoldAnime == "push" then
					self:SetAnimation("push")
					animeSpeed = 1.0
				elseif self.mHoldAnime == "pull" then
					self:SetAnimation("pull")
					animeSpeed = 1.0
				elseif 20 < holdCount then
					self:SetAnimation("hold")
					animeSpeed = 1.0
				end
			else
				self:SetAnimation("stand")
				animeSpeed = 1.0
			end
		else
			self:SetAnimation("fall")
			animeSpeed = 3.0
		end
	end

	--Aj[V
	self:Animation(animeSpeed)
end

--Aj[V֐yAj[ṼXs[hz
function player_chara:Animation(speed)

	--Aj[VJEgAbv
	for key, state in pairs(self.mAnimeState) do
		state.mCount = state.mCount + speed
	end

	-------------------------------------------------------------------------------------------------------

	--[VAj
	local s_flag     = self.mAnimeState["stand"].mFlag
	local s_count    = self.mAnimeState["stand"].mCount
	local s_preCount = self.mAnimeState["stand"].mPreCount
	local s_bodyY = 0.0
	local s_legY = 0.0
	local s_armPi = 0.0
	local s_nejiAy = 0.0
	local s_antennaAz2 = 0.0
	local s_count2 = self.mCount % (60*2)
	local s_count5 = self.mCount % (60*5)
	local s_countArm2 = s_flag and s_count % (60*2) or (s_preCount + s_count) % (60*2)

	if (0 <= s_countArm2) and (s_countArm2 < 60) then
		local cnt = s_countArm2
		s_armPi = GetSmoothValue(5, 60, cnt)
	elseif (60 <= s_countArm2) and (s_countArm2 < 60*2) then
		local cnt = s_countArm2 - 60
		s_armPi = 5 - GetSmoothValue(5, 60, cnt)
	end

	if (0 <= s_count2) and (s_count2 < 60) then
		local cnt = s_count2
		s_bodyY = GetSmoothValue(0.05, 60, cnt)
		s_legY = GetSmoothValue(-0.05, 60, cnt)
		s_armPi = GetSmoothValue(5, 60, cnt)
		s_nejiAy = GetSmoothValue(180, 60, cnt)
		s_antennaAz2 = GetSmoothValue(3, 60, cnt)
	elseif (60 <= s_count2) and (s_count2 < 60*2) then
		local cnt = s_count2 - 60
		s_bodyY = 0.05 - GetSmoothValue(0.05, 60, cnt)
		s_legY = GetSmoothValue(0.05, 60, cnt) + (-0.05)
		s_armPi = 5 - GetSmoothValue(5, 60, cnt)
		s_nejiAy = 180 + GetSmoothValue(180, 60, cnt)
		s_antennaAz2 = 3 - GetSmoothValue(3, 60, cnt)
	end

	local antennaAz = 0.0
	local antennaAy = 0.0

	if (0 <= s_count5) and (s_count5 < 30) then
		local cnt = s_count5
		s_antennaAz = GetSmoothValue(10, 30, cnt)
		s_antennaAy = GetSmoothValue(180, 30, cnt)
	elseif (30 <= s_count5) and (s_count5 < 60) then
		local cnt = s_count5 - 30
		s_antennaAz = 10 - GetSmoothValue(10, 30, cnt)
		s_antennaAy = 180 + GetSmoothValue(360, 30, cnt)
	elseif (60 <= s_count5) and (s_count5 < 90) then
		local cnt = s_count5 - 60
		s_antennaAz = GetSmoothValue(-10, 30, cnt)
		s_antennaAy = GetSmoothValue(-180, 30, cnt)
	elseif (90 <= s_count5) and (s_count5 < 120) then
		local cnt = s_count5 - 90
		s_antennaAz = GetSmoothValue(10, 30, cnt) - 10
		s_antennaAy = GetSmoothValue(360, 30, cnt) - 180
	end

	--Aj[Virj̉ex𔽉f
	if s_flag == true and s_count < 30 then
		local attenuation = s_count / 30
		s_armPi = s_armPi * attenuation
	elseif s_flag == false then
		local attenuation = 1.0 / ( (s_count / 10) + 1)
		s_armPi = s_armPi * attenuation
	end

	-------------------------------------------------------------------------------------------------------

	--[VAj
	local w_flag     = self.mAnimeState["walk"].mFlag
	local w_count    = self.mAnimeState["walk"].mCount
	local w_preCount = self.mAnimeState["walk"].mPreCount
	local w_bodyAy = 0
	local w_headAy = 0
	local w_armAx = 0
	local w_armAz = 10
	local w_legAx = 0
	local w_bodyAx = 15
	local w_headAx = 10
	local w_count1 = w_flag and w_count % 60 or (w_preCount + w_count) % 60

	if (0 <= w_count1) and (w_count1 < 30) then
		local cnt = w_count1
		w_bodyAy = -20 + GetSmoothValue(40, 30, cnt)
		w_headAy = 7 + GetSmoothValue(-14, 30, cnt)
		w_armAx = -20 + GetSmoothValue(40, 30, cnt)
		w_legAx = 40 + GetSmoothValue(-80, 30, cnt)
	elseif (30 <= w_count1) and (w_count1 < 60) then
		local cnt = w_count1 - 30
		w_bodyAy = 20 + GetSmoothValue(-40, 30, cnt)
		w_headAy = -7 + GetSmoothValue(14, 30, cnt)
		w_armAx = 20 + GetSmoothValue(-40, 30, cnt)
		w_legAx = -40 + GetSmoothValue(80, 30, cnt)
	end

	--Aj[V̉ex𔽉f
	if w_flag == true and w_count < 60 then
		local attenuation = w_count / 60
		w_bodyAy = w_bodyAy * attenuation
		w_headAy = w_headAy * attenuation
		w_armAx = w_armAx * attenuation
		w_legAx = w_legAx * attenuation
		w_bodyAx = w_bodyAx * attenuation
		w_headAx = w_headAx * attenuation
	elseif w_flag == false then
		local attenuation = 1.0 / ( (w_count / 30) + 1)
		local attenuation2 = 1.0 / ( (w_count / 7) + 1)
		w_bodyAy = w_bodyAy * attenuation
		w_headAy = w_headAy * attenuation
		w_armAx = w_armAx * attenuation
		w_legAx = w_legAx * attenuation2
		w_bodyAx = w_bodyAx * attenuation2
		w_headAx = w_headAx * attenuation
	end

	-------------------------------------------------------------------------------------------------------

	--Wv[VAj
	local j_flag     = self.mAnimeState["jump"].mFlag
	local j_count    = self.mAnimeState["jump"].mCount
	local j_preCount = self.mAnimeState["jump"].mPreCount
	local j_bodyAy = 360 --ŏI_n_
	local j_headAy = 0
	local j_headAx = 20
	local j_armAz = 30
	local j_legAx = 50
	local j_count0 = j_flag and j_count or (j_preCount + j_count)

	if (0 <= j_count0) and (j_count0 < 60) then
		local cnt = j_count0
		j_bodyAy = GetSmoothValue(360, 60, cnt)
	end

	if (0 <= j_count0) and (j_count0 < 30) then
		local cnt = j_count0
		j_headAy = GetSmoothValue(40, 30, cnt)
	elseif (30 <= j_count0) and (j_count0 < 60) then
		local cnt = j_count0 - 30
		j_headAy = 40 + GetSmoothValue(-40, 30, cnt)
	end

	--Aj[Ve㐔l̓Ȃ̂w
	if j_flag == false then
		j_bodyAy = GetSmoothValue(360, 60, j_preCount)
		if 180 <= j_bodyAy then j_bodyAy = -(360 - j_bodyAy) end
	end

	--Aj[V̉ex𔽉f
	if j_flag == true and j_count < 10 then
		local attenuation = j_count / 10
		j_bodyAy = j_bodyAy * attenuation
		j_headAy = j_headAy * attenuation
		j_armAz = j_armAz * attenuation
		j_legAx = j_legAx * attenuation
		j_headAx = j_headAx * attenuation
	elseif j_flag == false then
		local attenuation = 1.0 / ( (j_count / 7) + 1)
		j_bodyAy = j_bodyAy * attenuation
		j_headAy = j_headAy * attenuation
		j_armAz = j_armAz * attenuation
		j_legAx = j_legAx * attenuation
		j_headAx = j_headAx * attenuation
	end

	-------------------------------------------------------------------------------------------------------

	--[VAj
	local f_flag     = self.mAnimeState["fall"].mFlag
	local f_count    = self.mAnimeState["fall"].mCount
	local f_preCount = self.mAnimeState["fall"].mPreCount
	local f_headAx = -20
	local f_armAz = 30
	local f_legAx = -30
	local f_count1 = f_flag and f_count % 60 or (f_preCount + f_count) % 60

	if (0 <= f_count1) and (f_count1 < 30) then
		local cnt = f_count1
		f_armAz = 30 + GetSmoothValue(10, 30, cnt)
	elseif (30 <= f_count1) and (f_count1 < 60) then
		local cnt = f_count1 - 30
		f_armAz = 40 + GetSmoothValue(-10, 30, cnt)
	end

	--Aj[V̉ex𔽉f
	if f_flag == true and f_count < 30 then
		local attenuation = f_count / 30
		f_armAz = f_armAz * attenuation
		f_legAx = f_legAx * attenuation
		f_headAx = f_headAx * attenuation
	elseif f_flag == false then
		local attenuation = 1.0 / ( (f_count / 7) + 1)
		f_armAz = f_armAz * attenuation
		f_legAx = f_legAx * attenuation
		f_headAx = f_headAx * attenuation
	end

	-------------------------------------------------------------------------------------------------------

	--[VAj
	local h_flag     = self.mAnimeState["push"].mFlag
	local h_count    = self.mAnimeState["push"].mCount
	local h_preCount = self.mAnimeState["push"].mPreCount
	local h_armAx = 100
	local h_armAz = 25
	local h_legAx = 0
	local h_bodyAx = 35
	local h_headAx = 30
	local h_count1 = h_flag and h_count % 60 or (h_preCount + h_count) % 60

	if (0 <= h_count1) and (h_count1 < 30) then
		local cnt = h_count1
		h_bodyAx = 35 - 15 + GetSmoothValue(15, 30, cnt)
		h_legAx = 35 + GetSmoothValue(-80, 30, cnt)
	elseif (30 <= h_count1) and (h_count1 < 60) then
		local cnt = h_count1 - 30
		h_bodyAx = 35 + GetSmoothValue(-15, 30, cnt)
		h_legAx = -35 + GetSmoothValue(80, 30, cnt)
	end

	--Aj[V̉ex𔽉f
	if h_flag == true and h_count < 20 then
		local attenuation = h_count / 20
		h_armAx = h_armAx * attenuation
		h_armAz = h_armAz * attenuation
		h_legAx = h_legAx * attenuation
		h_bodyAx = h_bodyAx * attenuation
		h_headAx = h_headAx * attenuation
	elseif h_flag == false then
		local attenuation = 1.0 / ( (h_count / 10) + 1)
		local attenuation2 = 1.0 / ( (h_count / 7) + 1)
		h_armAx = h_armAx * attenuation
		h_armAz = h_armAz * attenuation
		h_legAx = h_legAx * attenuation2
		h_bodyAx = h_bodyAx * attenuation2
		h_headAx = h_headAx * attenuation
	end

	-------------------------------------------------------------------------------------------------------

	--[VAj
	local l_flag     = self.mAnimeState["pull"].mFlag
	local l_count    = self.mAnimeState["pull"].mCount
	local l_preCount = self.mAnimeState["pull"].mPreCount
	local l_armAx = 30
	local l_armAz = -20
	local l_legAx = 0
	local l_bodyAx = -25
	local l_headAx = -30
	local l_count1 = l_flag and l_count % 60 or (l_preCount + l_count) % 60

	if (0 <= l_count1) and (l_count1 < 30) then
		local cnt = l_count1
		l_bodyAx = -35 - 15 + GetSmoothValue(15, 30, cnt)
		l_legAx = 40 + GetSmoothValue(-80, 30, cnt)
	elseif (30 <= l_count1) and (l_count1 < 60) then
		local cnt = l_count1 - 30
		l_bodyAx = -35 + GetSmoothValue(-15, 30, cnt)
		l_legAx = -40 + GetSmoothValue(80, 30, cnt)
	end

	--Aj[V̉ex𔽉f
	if l_flag == true and l_count < 20 then
		local attenuation = l_count / 20
		l_armAx = l_armAx * attenuation
		l_armAz = l_armAz * attenuation
		l_legAx = l_legAx * attenuation
		l_bodyAx = l_bodyAx * attenuation
		l_headAx = l_headAx * attenuation
	elseif l_flag == false then
		local attenuation = 1.0 / ( (l_count / 10) + 1)
		local attenuation2 = 1.0 / ( (l_count / 7) + 1)
		l_armAx = l_armAx * attenuation
		l_armAz = l_armAz * attenuation
		l_legAx = l_legAx * attenuation2
		l_bodyAx = l_bodyAx * attenuation2
		l_headAx = l_headAx * attenuation
	end

	-------------------------------------------------------------------------------------------------------

	--[VAj
	local d_flag     = self.mAnimeState["hold"].mFlag
	local d_count    = self.mAnimeState["hold"].mCount
	local d_preCount = self.mAnimeState["hold"].mPreCount
	local d_armAx = 100
	local d_armAz = 25
	local d_legAx = -35
	local d_bodyAx = 35
	local d_headAx = 30
	local d_count1 = d_flag and d_count % 60 or (d_preCount + d_count) % 60

	--Aj[V̉ex𔽉f
	if d_flag == true and d_count < 20 then
		local attenuation = d_count / 20
		d_armAx = d_armAx * attenuation
		d_armAz = d_armAz * attenuation
		d_legAx = d_legAx * attenuation
		d_bodyAx = d_bodyAx * attenuation
		d_headAx = d_headAx * attenuation
	elseif d_flag == false then
		local attenuation = 1.0 / ( (d_count / 10) + 1)
		local attenuation2 = 1.0 / ( (d_count / 7) + 1)
		d_armAx = d_armAx * attenuation
		d_armAz = d_armAz * attenuation
		d_legAx = d_legAx * attenuation2
		d_bodyAx = d_bodyAx * attenuation2
		d_headAx = d_headAx * attenuation
	end

	-------------------------------------------------------------------------------------------------------

	--{fB
	self.mBody:SetMatrix("yxz",
		-w_bodyAx -h_bodyAx -l_bodyAx -d_bodyAx,
		w_bodyAy +j_bodyAy,
		0,
		Vector3C(0, s_bodyY, 0),
		self.mMatrix
	)
	rBodyMatrix = self.mBody:GetMatrix()


	--A[F
	self.mArmL:SetMatrix("yzx",
		w_armAx +h_armAx +l_armAx +d_armAx,
		0,
		25 +s_armPi +j_armAz +w_armAz +f_armAz +h_armAz +l_armAz +d_armAz,
		Vector3C(0.4, 0.7, 0),
		rBodyMatrix
	)
	--A[FE
	self.mArmR:SetMatrix("yzx",
		-w_armAx +h_armAx +l_armAx +d_armAx,
		180,
		-25 -s_armPi -j_armAz -w_armAz -f_armAz -h_armAz -l_armAz -d_armAz,
		Vector3C(-0.4, 0.7, 0),
		rBodyMatrix
	)


	--wbh
	self.mHead:SetMatrix("yxz",
		w_headAx +j_headAx +f_headAx +h_headAx +l_headAx +d_headAx,
		w_headAy +j_headAy,
		0,
		Vector3C(0, 0.80, -0.25),
		rBodyMatrix
	)
	rHeadMatrix = self.mHead:GetMatrix()

	--bÕf[^܂Ƃ
	local leftLegDiffX  = w_legAx -j_legAx -f_legAx -h_legAx -l_legAx -d_legAx
	local rightLegDiffX = w_legAx +j_legAx +f_legAx -h_legAx -l_legAx +d_legAx

	--bOF
	self.mLegL:SetMatrix("xyz",
		leftLegDiffX,
		0,
		0,
		Vector3C(0.25, -0.6 + s_legY, -0.05),
		rBodyMatrix
	)
	--bOFE
	self.mLegR:SetMatrix("xyz",
		rightLegDiffX,
		180,
		0,
		Vector3C(-0.25, -0.6 + s_legY, -0.05),
		rBodyMatrix
	)

	--AeiF
	self.mAntennaL:SetMatrix("yxz",
		0,
		s_antennaAy,
		-45 +s_antennaAz -s_antennaAz2,
		Vector3C(0.35, 0.75, 0.2),
		rHeadMatrix
	)
	--AeiFE
	self.mAntennaR:SetMatrix("yxz",
		0,
		s_antennaAy,
		45 +s_antennaAz +s_antennaAz2,
		Vector3C(-0.35, 0.75, 0.2),
		rHeadMatrix
	)

	--lW
	self.mNeji:SetMatrix("yxz", 70, s_nejiAy, 0, Vector3C(0, 0.15, 0.4), rBodyMatrix)


	--Ăꍇɑ炷
	if rightLegDiffX < -10 then
		self.mRightLegSoundState:Change(true)
	else
		self.mRightLegSoundState:Change(false)
	end
	if 10 <leftLegDiffX then
		self.mLeftLegSoundState:Change(true)
	else
		self.mLeftLegSoundState:Change(false)
	end
	if self.mMoveFlag == true and self.mJumpStartFlag == false and 20 < self.mCount then
		if self.mRightLegSoundState.mFlag == true and self.mRightLegSoundState.mCount == 0 then
			WAVESOUND:Play(WPath("kick_"..rand.range(0, 4) ), self.mPosition, self.mVelocity, 5, 200)
		end
		if self.mLeftLegSoundState.mFlag == true and self.mLeftLegSoundState.mCount == 0 then
			WAVESOUND:Play(WPath("kick_"..rand.range(0, 4) ), self.mPosition, self.mVelocity, 5, 200)
		end
	end
	self.mRightLegSoundState:CountUp(1)
	self.mLeftLegSoundState:CountUp(1)
end
