
--XNvg[h
--_G.OnReload = function() print("title_scene _G.OnReload") end

--^CgV[NX
Class("title_scene", scene)({})

--RXgN^
function title_scene:constructor(...)
	self.super:constructor(...)
	
	--WCpbhgpĂ邩`FbN
	if EXINPUT:JoyStickUsed() == true then
		graph = "title_balloon_button"
	else
		graph = "title_balloon_space"
	end     

	--oϐ
	self.mBack     = RENDERER:CreateSprite(TPath("title_back") )    --wi
	self.mAntennaA = RENDERER:CreateSprite(TPath("title_antenna") ) --AeiA
	self.mAntennaB = RENDERER:CreateSprite(TPath("title_antenna") ) --AeiB
	self.mFace     = RENDERER:CreateSprite(TPath("title_face") )    --
	self.mBalloon  = RENDERER:CreateSprite(TPath(graph) )           --o
	self.mFrame    = RENDERER:CreateSprite(TPath("title_frame") )   --̃t[
	self.mBlack    = RENDERER:CreateSprite(TPath("white") )         --^
	self.mTitle    = RENDERER:CreateSprite(TPath("title_title_u") ) --^Cg
	self.mTitleOn  = RENDERER:CreateSprite(TPath("title_title") )   --^Cg

	--`揇
	self.mBack:SetOrder(0)
	self.mAntennaA:SetOrder(1)
	self.mAntennaB:SetOrder(1)
	self.mFace:SetOrder(2)
	self.mBalloon:SetOrder(3)
	self.mFrame:SetOrder(4)
	self.mBlack:SetOrder(5)
	self.mTitle:SetOrder(6)
	self.mTitleOn:SetOrder(7)

	--tF[hiCxg̉ʌʓj̍쐬
	self.mFade = fade:factory()
	self.mFade.mFadeState:Set(false, 60)

	--
	self.mExitState  = state:factory() --I

	--^CgËʒu
	self.mTitlePosition = Vector3C(320, 240, 0)
	self.mFacePosition  = Vector3C(320, 240, 0)

	--õTCY
	self.mBalloonSizeX = 1.0
	self.mBalloonSizeY = 1.0
	self.mBalloonAngle = 0

	--S_̐ݒ
	self.mBlack:SetCenterPosition(1, 1)
	self.mBack:SetCenterPosition(0, 0)
	self.mAntennaA:SetCenterPosition(120, 320 + 50)
	self.mAntennaB:SetCenterPosition(120, 320 + 50)
	self.mFace:SetCenterPosition(256, 160)
	self.mBalloon:SetCenterPosition(120, 120)
	self.mFrame:SetCenterPosition(0, 0)
	self.mTitle:SetCenterPosition(0, 0)
	self.mTitleOn:SetCenterPosition(0, 0)

	--ݒ
	self.mAntennaA:Enabled(false)
	self.mAntennaB:Enabled(false)
	self.mFace:Enabled(false)
	self.mBalloon:Enabled(false)
	self.mTitleOn:Enabled(false)
	self.mBlack:SetMatrix(MatrixC:MkScaling(320, 240, 0) * MatrixC:MkTranslation(320, 240, 0) )
	self.mBlack:SetColor(COLOR(255, 0, 0, 0) )

	--BGM炷
	MP3SOUND:Play(MPath("title"), true, MilSecTo(0), MilSecTo(67900) )
	MP3SOUND:SetVolume(MPath("title"), -10000)
end

--s֐
function title_scene:Run()

	--ݒup
	--[[
	local moveVec = self.mHoge
	local diff = 1
	if 0 < INPUT.LEFT then moveVec.x = moveVec.x - diff end
	if 0 < INPUT.RIGHT then moveVec.x = moveVec.x + diff end
	if 0 < INPUT.FORE then moveVec.y = moveVec.y - diff end
	if 0 < INPUT.BACK then moveVec.y = moveVec.y + diff end
	if 0 < INPUT.UP then moveVec.z = moveVec.z + diff end
	if 0 < INPUT.DOWN then moveVec.z = moveVec.z - diff end
	--]]

	--V[JnBGM̃{[Xɏグ
	if self.mCount < 60 then
		MP3SOUND:SetVolume(MPath("title"), (-1500 / 60) * (60 - self.mCount) - 500)
		MP3SOUND:SetVolume(MPath("main"), (-5000 / 60) * self.mExitState.mCount)
	end

	--V[IBGM̃{[Xɉ
	if self.mExitState.mFlag == true then
		MP3SOUND:SetVolume(MPath("title"), (-5000 / 60) * self.mExitState.mCount)
	end

	--IԕύX
	if (INPUT.DECIDE == 1 or INPUT.CANCEL == 1) and 60*2 < self.mCount then
		self.mExitState:Change(true)
		self.mFade:FadeIn("circle", 10.0)
	end

	--艹炷
	if self.mExitState.mFlag == true and self.mExitState.mCount == 0 then
		WAVESOUND:Play(WPath("start"), 0, 0)
	end

	--^Cg
	if 60 < self.mCount and self.mCount < 120 then
		self.mTitleOn:Enabled(true)
		self.mTitleOn:SetColor(COLOR( (100 / 60) * (self.mCount - 60), 255, 255, 255) )
	end

	--^Cg̈ړ
	if self.mCount < 50 then
		local cnt   = self.mCount
		local start = TMP_VECTOR:Set(0, -200, 0)
		local term  = TMP_VECTOR_A:Set(0, 200, 0)
		self.mTitlePosition:Set(start + GetSmoothValue(term, 49, cnt) )
		self.mTitle:SetColor(COLOR( (255 / 50) * self.mCount, 255, 255, 255) )
	end

	--^Cg̍sݒ
	self.mTitle:SetMatrix(TMP_MATRIX:Translation(self.mTitlePosition) )

	--Âwi𖾂邭
	if self.mCount < 60 then
		self.mBlack:SetColor(COLOR(255 - (255 / 60) * self.mCount, 0, 0, 0) )
	end

	--̈ړ
	local faceDiff = 15
	if faceDiff < self.mCount and self.mCount < faceDiff + 60 then
		local cnt   = self.mCount - faceDiff
		local cnt2  = (cnt <= 30) and cnt or 29
		local start = TMP_VECTOR:Set(656, 628, 0)
		local term  = TMP_VECTOR_A:Set( (470 - 656) * 2, (390 - 628) * 2, 0)
		local danc  = TMP_VECTOR_B:Set(0, 0, 0)
		if 30 < cnt then
			local aten = (60 - cnt) / 3
			danc = TMP_VECTOR_B:Set(math.sin(cnt/2.6) * aten, math.sin(cnt/2.6) * aten, 0)
		end
		self.mFacePosition:Set(start + GetSmoothValue(term, 59, cnt2) + danc)
		self.mFace:Enabled(true)

		--Aei
		self.mAntennaA:Enabled(true)
		self.mAntennaB:Enabled(true)
		self.mAntennaA:SetColor(COLOR( (255/30)*cnt2, 255, 255, 255) )
		self.mAntennaB:SetColor(COLOR( (255/30)*cnt2, 255, 255, 255) )

	elseif faceDiff + 70 < self.mCount then
		local cnt = self.mCount - (faceDiff + 70)
		self.mFacePosition:Set(476 + math.sin(cnt / 30) * 1, 397 + math.sin(cnt / 40) * 2, 0)
	end

	--̍sݒ
	self.mFace:SetMatrix(TMP_MATRIX:Translation(self.mFacePosition) )

	--Aei̍sݒ
	local antennaVec  = TMP_VECTOR:Set(self.mFacePosition)
	local antennaDiff = math.sin( (self.mCount + 70) / 40) * 12
	antennaVec.x = self.mFacePosition.x - 72
	antennaVec.y = self.mFacePosition.y + 10
	self.mAntennaA:SetMatrix(TMP_MATRIX_A:RotationZ(DEG_ANGLE(-45 + antennaDiff) ) * TMP_MATRIX:Translation(antennaVec) )
	antennaVec.x = self.mFacePosition.x + 65
	antennaVec.y = self.mFacePosition.y + 4
	self.mAntennaB:SetMatrix(TMP_MATRIX_A:RotationZ(DEG_ANGLE(36 + antennaDiff) ) * TMP_MATRIX:Translation(antennaVec) )

	--oo
	local balloonDiff = 40
	if balloonDiff < self.mCount and self.mCount < balloonDiff + 60 then
		local cnt   = self.mCount - balloonDiff
		local cnt2  = (cnt <= 30) and cnt or 29
		local danc  = 0
		local danc2 = 0
		if 30 < cnt then
			danc = math.sin(cnt/1.5) * ( (60 - cnt) / 25) * 0.1
			danc2 = math.sin(cnt/2.1) * ( (60 - cnt) / 25) * 0.1
		end
		self.mBalloonSizeX = (GetSmoothValue(1.0, 58, cnt2) + danc) * 2
		self.mBalloonSizeY = (GetSmoothValue(1.0, 58, cnt2) + danc2) * 2
		self.mBalloon:Enabled(true)

	elseif balloonDiff + 60 < self.mCount then
		local cnt = self.mCount - (balloonDiff + 60)
		self.mBalloonSizeX = 1.0 + math.sin(cnt / 20) * 0.03
		self.mBalloonSizeY = 1.0 + math.sin(cnt / 20) * 0.03
		self.mBalloonAngle = math.sin(cnt / 30) * 5
	end

	--ȏ傫ύX
	local balloonScale  = TMP_MATRIX:Scaling(self.mBalloonSizeX, self.mBalloonSizeY, 0)
	local balloonTrans  = TMP_MATRIX_A:Translation(122, 369, 0)
	local balloonRotate = TMP_MATRIX_B:RotationZ(DEG_ANGLE(self.mBalloonAngle) )
	self.mBalloon:SetMatrix(balloonScale * balloonRotate * balloonTrans)

	--tF[h̍XV
	self.mFade:Run()

	--Ԃ̃JEgAbv
	self.mExitState:CountUp(1)

	--fobO\
	if INI_DEBUG_MODE == true then
		LUA:DebugOut("̈ʒu", VecToString(self.mFacePosition) )
	end

	--V[
	local next = nil
	if self.mExitState.mFlag == true and self.mExitState.mCount == 70 then
		game.data.now_scene = "stage00_scene"
		game.data.now_place = "place_A"
		next = true
	end

	--_Os
	local pos = TMP_VECTOR:Set(0, 0, 0)
	local at  = TMP_VECTOR_A:Set(0, 0, 0)
	DEVICE:BeginRendering()
	RENDERER:Draw(pos, at)
	local lostFlag = DEVICE:EndRendering()

	--foCX̃Xg
	if lostFlag == true then

		--foCX̏Ԃ邽߁AĐݒs
		--self.mLight:Initialize() --
		--self.mLight:SetDirection(Vector3C(1.0, -1.0, 0.0):Normalize() )
		--self.mLight:Apply()
	end

	--JEgAbv
	self.mCount = self.mCount + 1

	--V[̕ύX邩
	return next
end

--fXgN^iOR[j
function title_scene:destructor()

	--XvCg
	RENDERER:Erase(self.mBlack)
	RENDERER:Erase(self.mBack)
	RENDERER:Erase(self.mAntennaA)
	RENDERER:Erase(self.mAntennaB)
	RENDERER:Erase(self.mFace)
	RENDERER:Erase(self.mBalloon)
	RENDERER:Erase(self.mFrame)
	RENDERER:Erase(self.mTitle)
	RENDERER:Erase(self.mTitleOn)

	--tF[h̉
	self.mFade:destructor()
	self.mFade = nil

	--`IuWFNg̉
	RENDERER:Clear()

	--fobOo͂NA
	LUA:DebugClear()
end

--[h֐
function title_scene:OnReload()
end
