
--XNvg[h
--_G.OnReload = function() print("stage02_scene _G.OnReload") end

--V[NX
Class("stage02_scene", map_scene)({})

--RXgN^
function stage02_scene:constructor(...)
	self.super:constructor(...)

	--oϐ
	self.mSwitchDownSize = 0                  --XCb`ǂꂾł邩
	self.mEnterEventA = state:factory()       --ɓuԂ̃Cxg
	self.mExitEventA = state:factory()        --oĂCxg
	self.mScaffoldingPopSize = 0              --̏o
	self.mScaffoldingEvent = state:factory()  --oCxg
	self.mScaffoldingFlag = false             --otO
	self.mBlockEvent = state:factory()        --ubN̉̃Cxg
	self.mBlockDiff = Vector3C()              --ubN̍ړς݃xNg
	self.mBlockVelocity = Vector3C()          --ubN̈ړxNg
	self.mBlockType = "first"                 --ubN̎
	self.mFirstBlockPlace = 3                 --ubN̏ʒu
	self.mDoubleBlockPlace = 1                --ubN̏ʒu
	self.mUnderBlockPlace = 1                 --ubN̏ʒu
	self.mBlockComplete = false               --ubN}ăn}̃tO
	self.mBlockEndEvent = state:factory()     --ubNn}̃Cxg
	self.mBlockEndFlag = false                --ubNn}Ă邩
	self.mBlockFallHeight = 0                  --ubN̗鍂
	self.mLeftGearAngle = 0                   --獶̎*4̊px
	self.mMoveGearAngle = 0                   --ғ鎕Ԃ̊px
	self.mRightGearAngle = 0                  --E̎*1̊px
	self.mGearAttenuation = 0                 --Ԃž
	self.mLiftState = state:factory()         --tg̉ғ
	self.mPreLiftHeight = 0                    --Õtg̍
	self.mLiftHeight = 0                       --tg̍
	self.mGearPushEvent = state:factory()     --ԂCxg
	self.mGearPushFlag = false                --Ԃݍς݂ǂ
	self.mGearPushSize = 0                    --Ԃ̉
	self.mTakeBlockEvent = state:factory()    --܂ĂubNCxg
	self.mTakeBlockFlag = false               --ubN𔲂I
	self.mTakeBlockSize = 0                   --܂ubN̈
	
	--tobecontinued̖
	self.mBlack = RENDERER:CreateSprite(TPath("white") )
	self.mBlack:SetCenterPosition(1, 1)
	self.mBlack:SetColor(COLOR(0, 0, 0, 0) )
	self.mBlack:SetMatrix(MatrixC:MkScaling(640, 480, 1) * MatrixC:MkTranslation(320, 240, 0) )

	--tobecontinued̕摜
	self.mTobe = RENDERER:CreateSprite(TPath("to_be_continued") )
	self.mTobe:SetCenterPosition(1, 1)
	self.mTobe:SetColor(COLOR(0, 255, 255, 255) )
	self.mTobe:SetMatrix(MatrixC:MkTranslation(250, 410, 0) )


	--vC[̐ݒ
	self:SetPlayerInDoor("stage02_enter_hit", 90)
	self.mPlayer:ChangeNeji(game.data.now_neji)

	--[[
	self.mPlayer.mPosition:Set(900, 1000, -500)
	self.mCamera:SetAngle(0)
	for i = 0, 1 do
		self.mPlayer:MoveDirection(Z_AXIS, 0, -1)
		self.mPlayer:ChangeSpeed(1.0)
		self.mPlayer:Run()
	end
	--]]

	--J̐ݒ
	self.mCamera:SetAngle(180)

	--}bv̓ǂݍ݁iLƂ̓蔻pj
	self.mMapList = {
		map = XPath("stage02"),
		--[[
		map0 = XPath("stage01_0"),
		map1 = XPath("stage01_1"),
		map2 = XPath("stage01_2"),
		map3 = XPath("stage01_3"),
		enter = XPath("stage01_enter"),
		exit = XPath("stage01_exit"),
		first_block = XPath("stage01_first_block"),
		double_block = XPath("stage01_double_block"),
		under_block = XPath("stage01_under_block"),
		gear_block = XPath("stage01_gear_block"),
		pop_block = XPath("stage01_pop_block"),
		lift = XPath("stage01_lift"),
		switch_a_hit = XPath("stage01_switch_a_hit"),
		switch_b_hit = XPath("stage01_switch_b_hit"),
		gear_hit = XPath("stage01_gear_hit"),
		gear_r2_hit = XPath("stage01_gear_r2_hit"),
		--]]
	}

	--}bṽ[hϊs쐬
	self.mMapMatrixList = {}
	for key, resource in pairs(self.mMapList) do
		self.mMapMatrixList[key] = MatrixC()
	end

	--}bv̕`IuWFNg쐬iJƂ̔ɂgpj
	self.mMapVisualList = {
		mMap = RENDERER:CreateModel(XPath("stage02") )
		--[[
		mMap0 = RENDERER:CreateModel(XPath("stage01_0") ),
		mMap1 = RENDERER:CreateModel(XPath("stage01_1") ),
		mMap2 = RENDERER:CreateModel(XPath("stage01_2") ),
		mMap3 = RENDERER:CreateModel(XPath("stage01_3") ),
		mEnter = RENDERER:CreateModel(XPath("stage01_enter") ),
		mExit = RENDERER:CreateModel(XPath("stage01_exit") ),
		mFirstBlock = RENDERER:CreateModel(XPath("stage01_first_block") ),
		mDoubleBlock = RENDERER:CreateModel(XPath("stage01_double_block") ),
		mUnderBlock = RENDERER:CreateModel(XPath("stage01_under_block") ),
		mGearBlock = RENDERER:CreateModel(XPath("stage01_gear_block") ),
		mPopBlock = RENDERER:CreateModel(XPath("stage01_pop_block") ),
		mLift = RENDERER:CreateModel(XPath("stage01_lift") ),
		mSwitchA = RENDERER:CreateModel(XPath("stage01_switch_a") ),
		mSwitchB = RENDERER:CreateModel(XPath("stage01_switch_b") ),
		mCore = RENDERER:CreateModel(XPath("stage01_core") ),
		mGearHit = RENDERER:CreateModel(XPath("stage01_gear_hit") ),
		mGearR2Hit = RENDERER:CreateModel(XPath("stage01_gear_r2_hit") ),
		--]]
	}

	--Ԃ̃IuWFNg쐬
	--[[
	self.mGearR1 = RENDERER:CreateModel(XPath("stage01_gear_r1") )
	self.mGearR2 = RENDERER:CreateModel(XPath("stage01_gear_r2") )
	self.mGearR3 = RENDERER:CreateModel(XPath("stage01_gear_r3") )
	self.mGearL1 = RENDERER:CreateModel(XPath("stage01_gear_l1") )
	self.mGearL2 = RENDERER:CreateModel(XPath("stage01_gear_l2") )
	self.mGearL3 = RENDERER:CreateModel(XPath("stage01_gear_l3") )
	--]]

	--`IuWFNgɉet
	for key, model in pairs(self.mMapVisualList) do
		model:SetShader(SHADOWMAP)
	end

	--eȂŕ`
	--[[
	self.mGearR1:SetShader(BASICSHADER)
	self.mGearR2:SetShader(BASICSHADER)
	self.mGearR3:SetShader(BASICSHADER)
	self.mGearL1:SetShader(BASICSHADER)
	self.mGearL2:SetShader(BASICSHADER)
	self.mGearL3:SetShader(BASICSHADER)
	--]]

	--Ԃ̓蔻\
	--[[
	self.mMapVisualList.mGearHit:Enabled(false)
	self.mMapVisualList.mGearR2Hit:Enabled(false)
	--]]

	--}bv̕`IuWFNg쐬
	for key, resource in pairs(self.mMapVisualList) do
		self[key] = resource
	end

	--ubNɉĂ
	--[[
	local matrix = TMP_MATRIX:Translation(0, -279, 0)
	self:SetListMatrix("pop_block", "mPopBlock", matrix)
	--]]

	--nP[E}b`ACe
	--[[
	local itemPos = TMP_VECTOR:Set(58, 0, 0)
	self.mHurricaneItem = spiral:factory("player_hurricane", spiral_hurricane, itemPos)
	itemPos:Set(144.8, 300, 426.5)
	self.mMuscleItem = spiral:factory("player_muscle", spiral_muscle, itemPos)
	--]]

	--eԂ̒S_L
	--[[
	self.mGearCenter = {
		r1 = Vector3C(XFILE:GetXFile(XPath("stage01_gear_r1") ).mOBBCenter),
		r2 = Vector3C(XFILE:GetXFile(XPath("stage01_gear_r2") ).mOBBCenter),
		r3 = Vector3C(XFILE:GetXFile(XPath("stage01_gear_r3") ).mOBBCenter),
		l1 = Vector3C(XFILE:GetXFile(XPath("stage01_gear_l1") ).mOBBCenter),
		l2 = Vector3C(XFILE:GetXFile(XPath("stage01_gear_l2") ).mOBBCenter),
		l3 = Vector3C(XFILE:GetXFile(XPath("stage01_gear_l3") ).mOBBCenter),
	}
	--]]

	--tg̏ԂԂ
	--self.mLiftState:Change("init")

	--tF[hAEg
	self.mFade:FadeOut("face", 10.0)

	--`惂f̌ݒ
	BASICSHADER:SetLightDirection(Vector3C(1.0, -1.0, 0.0) )
	SHADOWMAP:SetLightDirection(Vector3C(1.0, -1.0, 0.0) )

	--tHOݒ
	--DEVICE:SetFogState(COLOR(255, 255, 170, 0), 100, 5500)
	DEVICE:SetFogState(COLOR(50, 50, 0, 0), 1000, 1500)

	--fobOL[ڍו\
	print([[*** fobOL[ڍו\ ***]])
	print(" [P]L[FWvlWɐ؂ւB")
	print(" [O]L[F}b`lWɐ؂ւB")
	print(" [I]L[FEɈړB")
	print(" [U]L[FɈړB")

	--BGM炷
	--MP3SOUND:Play(MPath("main"), true, MilSecTo(0), MilSecTo(218608) )
	--MP3SOUND:SetVolume(MPath("main"), -1000)
end

--s֐
function stage02_scene:Run()

	--V[JnBGM̃{[Xɏグ
	if self.mCount < 60 then
		MP3SOUND:SetVolume(MPath("main"), (-1500 / 60) * (60 - self.mCount) + self.mBGMDiff)
	end

	--ֈړ
	if DEBUGINPUT.K_I == 1 then self.mPlayer.mPosition:Set(0, 313.99, 428.07) end
	if DEBUGINPUT.K_U == 1 then self.mPlayer.mPosition:Set(0, 313.99, -428.07) end
	
	--tobecontinued̍XV
	if 60 < self.mCount and self.mCount < 256+60 then
		self.mBlack:SetColor(COLOR(self.mCount - 60, 0, 0, 0) )
	end
	if 256+60 < self.mCount and self.mCount < 256+60+256 then
		self.mTobe:SetColor(COLOR(self.mCount - (256+60), 255, 255, 255) )
	end

	--Cxgn܂ĂȂ
	if self.mEnterEventA.mFlag == false and
		self.mExitEventA.mFlag == false and
		self.mScaffoldingEvent.mFlag == false and
		self.mGearPushEvent.mFlag == false and
		self.mTakeBlockEvent.mFlag == false and
		self.mBlockEndEvent.mFlag == false and
		60*2 > self.mCount
		then

		--vC[ړ
		moveFlag = self:PlayerMove() 

		--lWŗL̃ANV
		self:RunPlayerNejiAction()
	end

	--J̍XV
	local player = self.mPlayer --ȈՕ\Lp
	self.mCamera:Run(moveFlag, player.mPosition, player.mAngle, player:GetUnitSpeed(), self.mMapVisualList)

	--vC[̍XV
	self.mPlayer:Run()

	--{NX̍XV
	self.super:Run()

	--nP[E}b`ACeXV
	--self.mHurricaneItem:Run(self.mCamera.mPosition, self.mCamera.mAt, Y_AXIS)
	--self.mMuscleItem:Run(self.mCamera.mPosition, self.mCamera.mAt, Y_AXIS)

	--Ԃ]
	--self:RunLiftAndGear()

	--O̒nʂƃvC[ڐGĂۑ
	self.mPlayer.mPreOnLandFlag = self.mPlayer.mOnLandFlag

	--vC[Wv̂݁AVƂ̓蔻s
	local jumpFlag = self.mPlayer.mJumpStartFlag

	--vC[ƃ}bv̓蔻
	local hitData = self:PlayerToMap(jumpFlag)

	--nʂƐڐGĂ
	self.mPlayer.mOnLandFlag = hitData.landFlag

	--ubNQ𓮂
	--self:RunPushPullBlock(hitData)

	--WvlW擾Cxg
	--self:RunGetNeji("hurricane", "mHurricaneItem", "K_P")

	--}b`lW擾Cxg
	--self:RunGetNeji("muscle", "mMuscleItem", "K_O")

	--oCxg
	--self:RunScaffoldingEvent(hitData.landName)

	--ĂCxgXV
	self:RunEnterEvent("mEnterEventA", "stage02_enter_hit", -90, -1.0)

	--oĂCxgiočs玟̃V[ցj
	--[[
	local next = nil
	if self.mEnterEventA.mFlag == false then
		next = self:RunExitEvent("mExitEventA", "stage01_enter_hit", 180)
		if next == true then
			game.data.now_scene = "stage00_scene"
			game.data.now_place = "place_B"
		end
	end
	--]]

	--očsɉʂ
	--[[
	if self.mExitEventA.mFlag == true and 120 < self.mExitEventA.mCount then
		local cnt = self.mExitEventA.mCount - 120
		MP3SOUND:SetVolume(MPath("main"), (-5000 / 60) * cnt + self.mBGMDiff)
	end
	--]]
	
	--tobecontinued^Cgɖ߂
	local next = nil
	if self.mCount == 60*10 then
		game.data.now_scene = "title_scene"
		game.data.now_place = "place_none"
		next = true
	end
	
	--r[sݒ
	view = MatrixC:MkLookAtLH(self.mCamera.mPosition, self.mCamera.mAt, Y_AXIS)
	DEVICE:SetViewMatrix(view)

	--_Os
	DEVICE:BeginRendering()

	--vC[̉ef[^̍쐬
	self:SetShadowSetting()

	--`
	RENDERER:Draw(self.mCamera.mPosition, self.mCamera.mAt)
	local lostFlag = DEVICE:EndRendering()

	--foCX̃Xg
	if lostFlag == true then

		--foCX̏Ԃ邽߁AĐݒs
		self.mLight:Initialize() --
		self.mLight:SetDirection(Vector3C(1.0, -1.0, 0.0):Normalize() )
		self.mLight:Apply()
	end

	--fobOo
	if INI_DEBUG_MODE == true then
		self:DebugMessage()
		if hitData.wallName ~= nil then
			LUA:DebugOut("CfbNXl", hitData.wallName.." ["..hitData.index.."]")
		end
	end

	--JEgAbv
	self.mCount = self.mCount + 1

	--V[̕ύX邩
	return next
end

--fXgN^iOR[j
function stage02_scene:destructor()
	self.super:destructor()
end

--[h֐
function stage02_scene:OnReload()
end

--tgEԂ̓̏Ԃ؂ւy̖Oz
function stage02_scene:RunLiftAndGear(landName)

	--Õtg̍ۑ
	self.mPreLiftHeight = self.mLiftHeight

	--tgԂԂɐ؂ւ
	if self.mLiftState.mFlag == "init" then
		local cnt = (60 - (self.mLiftState.mCount % 180) ) / 20
		if (self.mLiftState.mCount % 180) < 60 then
			self.mLeftGearAngle = 0 + math.sin(self.mLiftState.mCount / 4) * cnt
			self.mLiftHeight = 0 + math.sin(self.mLiftState.mCount / 4) * cnt
		end
		self.mRightGearAngle = self.mRightGearAngle + 1

		--炷
		if self.mCount % 60 == 0 then
			WAVESOUND:Play(WPath("gear"), self.mGearCenter.r3, ZERO_VECTOR, 50, 2000)
		end
		if cnt == 3 then
			WAVESOUND:Play(WPath("gearstop"), self.mGearCenter.r1, ZERO_VECTOR, 10, 2000)
			WAVESOUND:Play(WPath("gearstop"), self.mGearCenter.l1, ZERO_VECTOR, 10, 2000)
			WAVESOUND:Play(WPath("gearstop"), self.mGearCenter.l2, ZERO_VECTOR, 10, 2000)
			WAVESOUND:Play(WPath("gearstop"), self.mGearCenter.l3, ZERO_VECTOR, 10, 2000)
		end
	end

	--tgԂԑ}Ԃɐ؂ւ
	if self.mLiftState.mFlag == "insert" then
	end

	--tgԂԑ}Ԃɐ؂ւ̂Q
	if self.mLiftState.mFlag == "insert2" then
		self.mLiftHeight = -550
		self.mLeftGearAngle = self.mLiftHeight
		self.mMoveGearAngle = self.mLiftHeight
		self.mRightGearAngle = self.mLiftHeight
	end

	--tgԂŜzɐ؂ւ
	if self.mLiftState.mFlag == "spasm" then
		local cnt = (60 - (self.mLiftState.mCount % 120) ) / 30
		if (self.mLiftState.mCount % 120) < 60 then
			self.mLeftGearAngle = 0 + math.sin(self.mLiftState.mCount / 4) * cnt
			self.mMoveGearAngle = 0 + math.sin(self.mLiftState.mCount / 4) * cnt
			self.mRightGearAngle = 0 + math.sin(self.mLiftState.mCount / 4) * cnt
			self.mLiftHeight = 0 + math.sin(self.mLiftState.mCount / 4) * cnt
		end
		if cnt == 2 then
			WAVESOUND:Play(WPath("gearstop"), self.mGearCenter.r1, ZERO_VECTOR, 10, 2000)
			WAVESOUND:Play(WPath("gearstop"), self.mGearCenter.r2, ZERO_VECTOR, 10, 2000)
			WAVESOUND:Play(WPath("gearstop"), self.mGearCenter.r3, ZERO_VECTOR, 10, 2000)
			WAVESOUND:Play(WPath("gearstop"), self.mGearCenter.l1, ZERO_VECTOR, 10, 2000)
			WAVESOUND:Play(WPath("gearstop"), self.mGearCenter.l2, ZERO_VECTOR, 10, 2000)
			WAVESOUND:Play(WPath("gearstop"), self.mGearCenter.l3, ZERO_VECTOR, 10, 2000)
		end
	end

	--tgԂÊ݉]Ԃɐ؂ւ
	if self.mLiftState.mFlag == "takeout" then
		if self.mLiftState.mCount < 60*3 then
			self.mLiftHeight = GetSmoothValue(-550, 60*3, self.mLiftState.mCount)
			self.mLeftGearAngle = self.mLiftHeight

			--炷
			if self.mCount % 10 == 0 then
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r1, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l1, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l2, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l3, ZERO_VECTOR, 10, 2000)
			end
		else
			--r܂œoĂ痎Ă܂
			local cnt = (self.mLiftState.mCount - 60*3) % (60*10)
			if cnt < 60*5 then
				self.mLiftHeight = -550 + GetSmoothValue(250, 60*5, cnt)

				--炷
				if self.mCount % 30 == 0 then
					WAVESOUND:Play(WPath("gear"), self.mGearCenter.r1, ZERO_VECTOR, 10, 2000)
					WAVESOUND:Play(WPath("gear"), self.mGearCenter.l1, ZERO_VECTOR, 10, 2000)
					WAVESOUND:Play(WPath("gear"), self.mGearCenter.l2, ZERO_VECTOR, 10, 2000)
					WAVESOUND:Play(WPath("gear"), self.mGearCenter.l3, ZERO_VECTOR, 10, 2000)
				end
			elseif cnt < 60*6 then
				self.mLiftHeight = -300 + GetSmoothValue(-250*2, 60*2, cnt - 60*5)

				--炷
				if self.mCount % 10 == 0 then
					WAVESOUND:Play(WPath("gear"), self.mGearCenter.r1, ZERO_VECTOR, 10, 2000)
					WAVESOUND:Play(WPath("gear"), self.mGearCenter.l1, ZERO_VECTOR, 10, 2000)
					WAVESOUND:Play(WPath("gear"), self.mGearCenter.l2, ZERO_VECTOR, 10, 2000)
					WAVESOUND:Play(WPath("gear"), self.mGearCenter.l3, ZERO_VECTOR, 10, 2000)
				end
			elseif cnt < 60*7 then
				local atten = (60 - (cnt - 60*6) ) / 30
				self.mLiftHeight = -550 + math.sin( (cnt - 60*6) / 4) * atten
			end
			self.mLeftGearAngle = self.mLiftHeight
		end
		self.mRightGearAngle = self.mRightGearAngle + 1

		--炷
		if self.mCount % 60 == 0 then
			WAVESOUND:Play(WPath("gear"), self.mGearCenter.r3, ZERO_VECTOR, 50, 2000)
		end
	end

	--tgԂ~Ԃɐ؂ւ
	if self.mLiftState.mFlag == "updown" then
		local cnt = self.mLiftState.mCount % (60*20)
		if cnt < 60*7 then
			self.mLiftHeight = -550 + GetSmoothValue(550, 60*7, cnt)


			--炷
			if self.mCount % 30 == 0 then
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r1, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r2, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r3, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l1, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l2, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l3, ZERO_VECTOR, 10, 2000)
			end
		end
		if 60*10 <= cnt and cnt < 60*17 then
			self.mLiftHeight = 0 + GetSmoothValue(-550, 60*7, cnt - 60*10)

			--炷
			if self.mCount % 30 == 0 then
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r1, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r2, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r3, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l1, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l2, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l3, ZERO_VECTOR, 10, 2000)
			end
		end
		self.mLeftGearAngle = self.mLiftHeight
		self.mMoveGearAngle = self.mLiftHeight
		self.mRightGearAngle = self.mLiftHeight
	end

	--tgԂԂɐ؂ւ
	if self.mLiftState.mFlag == "downup" then
		local cnt = self.mLiftState.mCount % (60*20)
		if cnt < 60*7 then
			self.mLiftHeight = 0 + GetSmoothValue(-550, 60*7, cnt)

			--炷
			if self.mCount % 30 == 0 then
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r1, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r2, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r3, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l1, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l2, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l3, ZERO_VECTOR, 10, 2000)
			end
		end
		if 60*10 <= cnt and cnt < 60*17 then
			self.mLiftHeight = -550 + GetSmoothValue(550, 60*7, cnt - 60*10)

			--炷
			if self.mCount % 30 == 0 then
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r1, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r2, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.r3, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l1, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l2, ZERO_VECTOR, 10, 2000)
				WAVESOUND:Play(WPath("gear"), self.mGearCenter.l3, ZERO_VECTOR, 10, 2000)
			end
		end
		self.mLeftGearAngle = self.mLiftHeight
		self.mMoveGearAngle = self.mLiftHeight
		self.mRightGearAngle = self.mLiftHeight
	end

	--xSɈړĉ]Ă猳̈ʒu
	local toCenter  = TMP_MATRIX
	local trans     = TMP_MATRIX_A
	local rotRightX = TMP_MATRIX_B
	local rotLeftX  = TMP_MATRIX_C
	local trans2    = TMP_MATRIX_D

	--E1
	toCenter = TMP_MATRIX:Translation(-self.mGearCenter.r1.x, -self.mGearCenter.r1.y, -self.mGearCenter.r1.z)
	rotRightX = TMP_MATRIX_B:RotationX(DEG_ANGLE(self.mLeftGearAngle) )
	trans = TMP_MATRIX_A:Translation(self.mGearCenter.r1)
	self.mGearR1:SetMatrix(toCenter * rotRightX * trans)

	--E2
	toCenter = TMP_MATRIX:Translation(-self.mGearCenter.r2.x, -self.mGearCenter.r2.y, -self.mGearCenter.r2.z)
	rotRightX = TMP_MATRIX_B:RotationX(DEG_ANGLE(-self.mMoveGearAngle) )
	trans = TMP_MATRIX_A:Translation(self.mGearCenter.r2)
	trans2 = TMP_MATRIX_D:Translation(-self.mGearPushSize, 0, 0)
	self.mGearR2:SetMatrix(toCenter * rotRightX * trans * trans2)

	--E3
	toCenter = TMP_MATRIX:Translation(-self.mGearCenter.r3.x, -self.mGearCenter.r3.y, -self.mGearCenter.r3.z)
	rotRightX = TMP_MATRIX_B:RotationX(DEG_ANGLE(self.mRightGearAngle) )
	trans = TMP_MATRIX_A:Translation(self.mGearCenter.r3)
	self.mGearR3:SetMatrix(toCenter * rotRightX * trans)

	--1
	toCenter = TMP_MATRIX:Translation(-self.mGearCenter.l1.x, -self.mGearCenter.l1.y, -self.mGearCenter.l1.z)
	rotLeftX  = TMP_MATRIX_C:RotationX(DEG_ANGLE(-self.mLeftGearAngle) )
	trans = TMP_MATRIX_A:Translation(self.mGearCenter.l1)
	self.mGearL1:SetMatrix(toCenter * rotLeftX * trans)

	--2
	toCenter = TMP_MATRIX:Translation(-self.mGearCenter.l2.x, -self.mGearCenter.l2.y, -self.mGearCenter.l2.z)
	rotLeftX  = TMP_MATRIX_C:RotationX(DEG_ANGLE(self.mLeftGearAngle) )
	trans = TMP_MATRIX_A:Translation(self.mGearCenter.l2)
	self.mGearL2:SetMatrix(toCenter * rotLeftX * trans)

	--3
	toCenter = TMP_MATRIX:Translation(-self.mGearCenter.l3.x, -self.mGearCenter.l3.y, -self.mGearCenter.l3.z)
	rotLeftX  = TMP_MATRIX_C:RotationX(DEG_ANGLE(-self.mLeftGearAngle) )
	trans = TMP_MATRIX_A:Translation(self.mGearCenter.l3)
	self.mGearL3:SetMatrix(toCenter * rotLeftX * trans)

	--tg𓮂
	trans = TMP_MATRIX_A:Translation(0, self.mLiftHeight, 0)
	self:SetListMatrix("lift", "mLift", trans)

	--Ԃ̃JEgAbv
	self.mLiftState:CountUp(1)
end

--oCxgy̖Oz
function stage02_scene:RunScaffoldingEvent(landName)

	--XCb`AoCxgJn
	if landName == "switch_a_hit" and self.mScaffoldingFlag == false then
		self.mScaffoldingEvent:Change(true) --oCxgJn
		self.mScaffoldingFlag = true    --͏oĂ
	end

	--hAJCxg
	if self.mScaffoldingEvent.mFlag == true then

		--CxgJnu
		if self.mScaffoldingEvent.mCount == 0 then
			self.mPlayer:Stop()             --vC[̓~
			self.mFade:Belt(true)           --f̂悤ȑтo
			self.mCamera:EnableMoving(true) --J̔Cӈړ\ɂ
		end

		--BGM̃{[
		if 5 <= self.mScaffoldingEvent.mCount and self.mScaffoldingEvent.mCount <= 60 + 5 then
			MP3SOUND:SetVolume(MPath("main"), (-1000 / 60) * self.mScaffoldingEvent.mCount + self.mBGMDiff)
		end
		
		--XCb`ݍޏ
		if 5 <= self.mScaffoldingEvent.mCount and self.mScaffoldingEvent.mCount <= 15 then
			
			--ꎞϐ
			local switchTrans = TMP_MATRIX
			local switchTrans2 = TMP_MATRIX_A

			--XCb`̒݋쐬
			self.mSwitchDownSize = self.mSwitchDownSize - 2.1
			switchTrans:Translation(0, self.mSwitchDownSize, 0)

			--JEgAXCb`𒾂܂
			if 11 <= self.mScaffoldingEvent.mCount then
				switchTrans2:Translation(0, self.mSwitchDownSize, 0)
			else
				switchTrans2:Translation(0, 0, 0)
			end
			self.mSwitchA:SetMatrix(switchTrans)
			self.mMapMatrixList.switch_a_hit:Set(switchTrans2)

			--XCb`މ炷
			if 15 == self.mScaffoldingEvent.mCount then
				WAVESOUND:Play(WPath("switch"), Vector3C(667, 10, 527), ZERO_VECTOR, 150, 200)
			end
		end

		--Jړ鏈iwʒuֈړj
		if 60 <= self.mScaffoldingEvent.mCount and self.mScaffoldingEvent.mCount < 60*2 then
			local cnt = self.mScaffoldingEvent.mCount - 60
			local maxPos = TMP_VECTOR:Set(825, 20, 216)
			local maxAt = TMP_VECTOR_A:Set(704, 34, 305)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)
		end

		--ꂪNďo鏈
		if 60*2 <= self.mScaffoldingEvent.mCount and self.mScaffoldingEvent.mCount < 60*4 then

			--[Jϐ
			local scaffoldingTrans  = TMP_MATRIX
			local dirtyPos          = TMP_VECTOR
			local cnt = self.mScaffoldingEvent.mCount - 60*2

			--Ɉړ
			self.mScaffoldingPopSize = GetSmoothValue(279, 60*2, cnt)
			scaffoldingTrans:Translation(0, -279 + self.mScaffoldingPopSize, 0)
			self:SetListMatrix("pop_block", "mPopBlock", scaffoldingTrans)

			--yo
			if self.mScaffoldingEvent.mCount % 10 == 0 then
				for i = 1, 4 do
					dirtyPos:Set(553, 5, 574 + i*11)
					self:DirtyDust(dirtyPos, 8, 50, 0.9, 0.1)
					dirtyPos:Set(553 - i*11, 5, 574)
					self:DirtyDust(dirtyPos, 8, 50, 0.9, 0.1)
					dirtyPos:Set(553, 5, 466 + i*13)
					self:DirtyDust(dirtyPos, 8, 50, 0.9, 0.1)
					dirtyPos:Set(553 - i*13, 5, 466)
					self:DirtyDust(dirtyPos, 8, 50, 0.9, 0.1)
					dirtyPos:Set(553, 5, 340 + i*14)
					self:DirtyDust(dirtyPos, 8, 50, 0.9, 0.1)
					dirtyPos:Set(553 - i*14, 5, 340)
					self:DirtyDust(dirtyPos, 8, 50, 0.9, 0.1)
					dirtyPos:Set(553, 5, 229 + i*15)
					self:DirtyDust(dirtyPos, 8, 50, 0.9, 0.1)
					dirtyPos:Set(553 - i*15, 5, 229)
					self:DirtyDust(dirtyPos, 8, 50, 0.9, 0.1)
				end
			end

			--o
			if self.mScaffoldingEvent.mCount < 60*4-1 then
				if self.mScaffoldingEvent.mCount % 30 == 0 then
					WAVESOUND:Play(WPath("gogo"), Vector3C(457, 0, 257), ZERO_VECTOR, 150, 200)
				end
				if self.mScaffoldingEvent.mCount % 30 == 4 then
					WAVESOUND:Play(WPath("gogo"), Vector3C(457, 0, 368), ZERO_VECTOR, 150, 200)
				end
				if self.mScaffoldingEvent.mCount % 30 == 7 then
					WAVESOUND:Play(WPath("gogo"), Vector3C(457, 0, 493), ZERO_VECTOR, 150, 200)
				end
				if self.mScaffoldingEvent.mCount % 30 == 11 then
					WAVESOUND:Play(WPath("gogo"), Vector3C(457, 0, 606), ZERO_VECTOR, 150, 200)
				end
				if self.mScaffoldingEvent.mCount % 30 == 0 then
					WAVESOUND:Play(WPath("gogogo"), Vector3C(457, 0, 380), ZERO_VECTOR, 150, 500)
				end
			end
		end

		--
		if self.mScaffoldingEvent.mCount == 60*4+30 then
			WAVESOUND:Play(WPath("mystery"), -700, 0)
		end

		--Jړ鏈iwʒuJnj
		if self.mScaffoldingEvent.mCount == 60*7 then

			--J̓KWŎZo
			local player = self.mPlayer
			self.mCamera:GetPosAt(false, false, player.mPosition, player.mAngle, player:GetUnitSpeed(), self.mMapVisualList)
		end

		--Jړ鏈ïʒuֈړj
		if 60*7 <= self.mScaffoldingEvent.mCount and self.mScaffoldingEvent.mCount < 60*8 then
			local cnt = 59 - (self.mScaffoldingEvent.mCount - 60*7)
			local maxPos = TMP_VECTOR:Set(825, 20, 216)
			local maxAt = TMP_VECTOR_A:Set(704, 34, 305)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)

			--BGM̃{[グ
			MP3SOUND:SetVolume(MPath("main"), (-1000 / 60) * cnt + self.mBGMDiff)
		end

		--Cxg̏I
		if self.mScaffoldingEvent.mCount == 60*8 then
			self.mFade:Belt(false)           --f̂悤ȑт
			self.mCamera:EnableMoving(false) --J̔CӈړI
		end

		--CxgI
		if (60*8) < self.mScaffoldingEvent.mCount then
			self.mScaffoldingEvent:Change(false)
		end
	end

	--JEgAbv
	self.mScaffoldingEvent:CountUp(1)
end

--ubNQ鏔y蔻z
function stage02_scene:RunPushPullBlock(hitData)

	--FYႢ̓NĂAL猩đOkƂ̕
	--W = "" ()
	--S = "" ()
	--E = "" ()
	--N = "k" ()

	--ԂɃz[hiԂĂȂLj
	local gear_f = ( (self.mGearPushFlag == false) and (hitData.wallName == "gear_r2_hit") or false )
	local gear_w = false
	local gear_s = gear_f and (hitData.index == 24 or hitData.index == 25)
	local gear_e = false
	local gear_n = false

	--Ԃɋ܂ĂubNɃz[h
	local jam_f = hitData.wallName == "gear_block"
	local jam_w = false
	local jam_s = jam_f and (hitData.index == 12 or hitData.index == 13)
	local jam_e = false
	local jam_n = false

	--ŏubNɃz[h
	local first_f = hitData.wallName == "first_block"
	local first_w = first_f and (hitData.index == 14 or hitData.index == 15)
	local first_s = first_f and (hitData.index == 12 or hitData.index == 13)
	local first_e = first_f and (hitData.index == 18 or hitData.index == 19)
	local first_n = false
	first_f = (first_w or first_s or first_e or first_n) --

	--ubNɃz[h
	local double_f = hitData.wallName == "double_block"
	local double_w = double_f and (hitData.index == 10 or hitData.index == 11)
	local double_s = false
	local double_e = double_f and (hitData.index == 14 or hitData.index == 15)
	local double_n = false

	--ubNɃz[h
	local under_f = hitData.wallName == "under_block"
	local under_w = false
	local under_s = under_f and (hitData.index == 0 or hitData.index == 1)
	local under_e = false
	local under_n = under_f and (hitData.index == 10 or hitData.index == 11)

	--ubNz[hĂ邩
	local holdEnableFlag = (first_f or double_f or under_f or gear_f or jam_f)

	--ubÑCxgƁAz[h
	if self.mBlockEvent.mFlag == true then holdEnableFlag = false end

	--z[hԂ̍XV
	local fixGearFlag = (self.mGearPushEvent.mFlag == true and self.mGearPushEvent.mCount < 60*2)
	local fixTakeFlag = (self.mTakeBlockEvent.mFlag == true and self.mTakeBlockEvent.mCount < 60*2)
	local fixFlag = (self.mBlockEvent.mFlag or fixGearFlag or fixTakeFlag)
	local hold, fixAnime = self:RunPlayerHold(hitData, holdEnableFlag, fixFlag)

	-------------------------------------------------------------------------------------------------------

	--ubNCxgJniŏubNǁj
	if hold == true and self.mBlockEvent.mFlag == false and self.mBlockEndFlag == false then

		--ŏubN
		--}ĉubNP̎ɉ\
		--R̎FW
		--Q̎FW牟EE牟
		--P̎FW牟EE
		if self.mUnderBlockPlace == 1 then
			if self.mFirstBlockPlace == 3 then
				if first_w == true and fixAnime == "pull" then
					self.mBlockDiff:Set(0, 0, 0)
					self.mBlockVelocity:Set(0, 0, -50/1.0 )
					self.mFirstBlockPlace = 2
					self.mBlockType = "first"
				end
			elseif self.mFirstBlockPlace == 2 then
				if first_w == true and fixAnime == "push" then
					self.mBlockDiff:Set(0, 0, -50)
					self.mBlockVelocity:Set(0, 0, 50/1.0 )
					self.mFirstBlockPlace = 3
					self.mBlockType = "first"
				end
				if first_w == true and fixAnime == "pull" then
					self.mBlockDiff:Set(0, 0, -50)
					self.mBlockVelocity:Set(0, 0, -50/1.0 )
					self.mFirstBlockPlace = 1
					self.mBlockType = "first"
				end
				if first_e == true and fixAnime == "push" then
					self.mBlockDiff:Set(0, 0, -50)
					self.mBlockVelocity:Set(0, 0, -50/1.0 )
					self.mFirstBlockPlace = 1
					self.mBlockType = "first"
				end
			elseif self.mFirstBlockPlace == 1 then
				if first_w == true and fixAnime == "push" then
					self.mBlockDiff:Set(0, 0, -100)
					self.mBlockVelocity:Set(0, 0, 50/1.0 )
					self.mFirstBlockPlace = 2
					self.mBlockType = "first"
				end
				if first_e == true and fixAnime == "pull" then
					self.mBlockDiff:Set(0, 0, -100)
					self.mBlockVelocity:Set(0, 0, 50/1.0 )
					self.mFirstBlockPlace = 2
					self.mBlockType = "first"
				end
			end
		end

		--ubN
		--}čŏubNP̎ɉ\
		--P̎FN牟ES
		--Q̎FN牟ES牟
		--R̎FNES牟
		if self.mFirstBlockPlace == 1 then
			local onFlag = (self.mDoubleBlockPlace == 1) and "under_double" or "under"
			if self.mUnderBlockPlace == 1 then
				if under_n == true and fixAnime == "push" then
					self.mBlockDiff:Set(0, 0, 0)
					self.mBlockVelocity:Set(50/1.0, 0, 0)
					self.mUnderBlockPlace = 2
					self.mBlockType = onFlag
				end
				if under_s == true and fixAnime == "pull" then
					self.mBlockDiff:Set(0, 0, 0)
					self.mBlockVelocity:Set(50/1.0, 0, 0)
					self.mUnderBlockPlace = 2
					self.mBlockType = onFlag
				end
			elseif self.mUnderBlockPlace == 2 then
				if under_n == true and fixAnime == "push" then
					self.mBlockDiff:Set(50, 0, 0)
					self.mBlockVelocity:Set(50/1.0, 0, 0)
					self.mUnderBlockPlace = 3
					self.mBlockType = onFlag
				end
				if under_n == true and fixAnime == "pull" then
					self.mBlockDiff:Set(50, 0, 0)
					self.mBlockVelocity:Set(-50/1.0, 0, 0)
					self.mUnderBlockPlace = 1
					self.mBlockType = onFlag
				end
				if under_s == true and fixAnime == "push" then
					self.mBlockDiff:Set(50, 0, 0)
					self.mBlockVelocity:Set(-50/1.0, 0, 0)
					self.mUnderBlockPlace = 1
					self.mBlockType = onFlag
				end
				if under_s == true and fixAnime == "pull" then
					self.mBlockDiff:Set(50, 0, 0)
					self.mBlockVelocity:Set(50/1.0, 0, 0)
					self.mUnderBlockPlace = 3
					self.mBlockType = onFlag
				end
			elseif self.mUnderBlockPlace == 3 then
				if under_n == true and fixAnime == "pull" then
					self.mBlockDiff:Set(100, 0, 0)
					self.mBlockVelocity:Set(-50/1.0, 0, 0)
					self.mUnderBlockPlace = 2
					self.mBlockType = onFlag
				end
				if under_s == true and fixAnime == "push" then
					self.mBlockDiff:Set(100, 0, 0)
					self.mBlockVelocity:Set(-50/1.0, 0, 0)
					self.mUnderBlockPlace = 2
					self.mBlockType = onFlag
				end
			end
		end

		--ubN
		--P̎FEiubNP̎ɉ\j
		--Q̎FW牟EE牟îƂubNRE牟ΏIj
		--R̎FWEE牟
		if self.mDoubleBlockPlace == 1 then
			if self.mUnderBlockPlace == 1 then
				if double_e == true and fixAnime == "pull" then
					self.mBlockDiff:Set(0, 0, 0)
					self.mBlockVelocity:Set(0, 0, 50/1.0 )
					self.mDoubleBlockPlace = 2
					self.mBlockType = "double"
				end
			end
		elseif self.mDoubleBlockPlace == 2 then
			if self.mUnderBlockPlace == 1 or self.mUnderBlockPlace == 2 then
				if double_w == true and fixAnime == "push" then
					self.mBlockDiff:Set(0, 0, 50)
					self.mBlockVelocity:Set(0, 0, 50/1.0 )
					self.mDoubleBlockPlace = 3
					self.mBlockType = "double"
				end
				if double_e == true and fixAnime == "pull" then
					self.mBlockDiff:Set(0, 0, 50)
					self.mBlockVelocity:Set(0, 0, 50/1.0 )
					self.mDoubleBlockPlace = 3
					self.mBlockType = "double"
				end
			end
			if self.mUnderBlockPlace == 1 then
				if double_e == true and fixAnime == "push" then
					self.mBlockDiff:Set(0, 0, 50)
					self.mBlockVelocity:Set(0, 0, -50/1.0 )
					self.mDoubleBlockPlace = 1
					self.mBlockType = "double"
				end
			elseif self.mUnderBlockPlace == 3 then
				if double_e == true and fixAnime == "pull" then
					self.mBlockDiff:Set(0, 0, 50)
					self.mBlockVelocity:Set(0, 0, 50/1.0 )
					self.mDoubleBlockPlace = 3
					self.mBlockType = "double"
				end
				if double_e == true and fixAnime == "push" then
					self.mBlockDiff:Set(0, 0, 50)
					self.mBlockVelocity:Set(0, 0, -50/1.0 )
					self.mDoubleBlockPlace = 1
					self.mBlockType = "double"
					self.mBlockComplete = true
				end
			end
		elseif self.mDoubleBlockPlace == 3 then
			if double_w == true and fixAnime == "pull" then
				self.mBlockDiff:Set(0, 0, 100)
				self.mBlockVelocity:Set(0, 0, -50/1.0 )
				self.mDoubleBlockPlace = 2
				self.mBlockType = "double"
			end
			if double_e == true and fixAnime == "push" then
				self.mBlockDiff:Set(0, 0, 100)
				self.mBlockVelocity:Set(0, 0, -50/1.0 )
				self.mDoubleBlockPlace = 2
				self.mBlockType = "double"
			end
		end

		if self.mBlockVelocity.x ~= 0 or self.mBlockVelocity.y ~= 0 or self.mBlockVelocity.z ~= 0 then
			self.mBlockEvent:Change(true)
			WAVESOUND:Play(WPath("zuri"), self.mPlayer.mPosition, ZERO_VECTOR, 150, 200)
			WAVESOUND:Play(WPath("zuri"), self.mPlayer.mPosition, ZERO_VECTOR, 150, 200)
			WAVESOUND:Play(WPath("zuri"), self.mPlayer.mPosition, ZERO_VECTOR, 150, 200)
		end
	end

	--ubNړ鏈
	if self.mBlockEvent.mFlag == true and self.mBlockEvent.mCount < 60*2 then
		--printv(GetSmoothDiff(self.mBlockVelocity, 60*2, self.mBlockEvent.mCount + 2)  )
		--printv(self.mBlockVelocity)
		--self.mBlockDiff:Set(self.mBlockDiff + self.mBlockVelocity)
		self.mBlockDiff:Set(self.mBlockDiff + GetSmoothDiff(self.mBlockVelocity, 60*2, self.mBlockEvent.mCount + 2) )
		local trans = TMP_MATRIX:Translation(self.mBlockDiff)
		--self.mPlayer.mPosition:Set(self.mPlayer.mPosition + self.mBlockVelocity)
		self.mPlayer.mPosition:Set(self.mPlayer.mPosition + GetSmoothDiff(self.mBlockVelocity, 60*2, self.mBlockEvent.mCount + 2) )
		
		--eubNɓKp
		if self.mBlockType == "first" then
			self:SetListMatrix("first_block", "mFirstBlock", trans)
		elseif self.mBlockType == "under" then
			self:SetListMatrix("under_block", "mUnderBlock", trans)
		elseif self.mBlockType == "double" then
			self:SetListMatrix("double_block", "mDoubleBlock", trans)
		elseif self.mBlockType == "under_double" then
			self:SetListMatrix("under_block", "mUnderBlock", trans)
			self:SetListMatrix("double_block", "mDoubleBlock", trans)
		end
		
		--eubN̓y
		if self.mBlockEvent.mCount % 5 == 0 then
			local centerPos = TMP_VECTOR
			local edgeVec   = TMP_VECTOR_A:Set(55, 0, 55)
			local dirtyPos  = TMP_VECTOR_B
			local rot       = TMP_MATRIX_A
			
			--ŏ̃ubN
			if self.mBlockType == "first" then
				centerPos:Set(447.12, -5, -381.37)
				centerPos:Set(centerPos + self.mBlockDiff)
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(0) ) )
				for i = 1, 3 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.x = dirtyPos.x - rand.range(0, 100)
					self:DirtyDust(dirtyPos, 5, 40, 0.6, 0.1)
				end
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(90) ) )
				for i = 1, 3 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.x = dirtyPos.x - rand.range(0, 100)
					self:DirtyDust(dirtyPos, 5, 40, 0.6, 0.1)
				end
				centerPos.y = 3
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(270) ) )
				for i = 1, 3 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.z = dirtyPos.z - rand.range(0, 100)
					self:DirtyDust(dirtyPos, 5, 40, 0.6, 0.1)
				end
				
			--̃ubN
			elseif self.mBlockType == "under" or self.mBlockType == "under_double" then
				centerPos:Set(350.45, -5, -382.83)
				centerPos:Set(centerPos + self.mBlockDiff)
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(0) ) )
				for i = 1, 3 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.z = dirtyPos.z - rand.range(0, 100)
					self:DirtyDust(dirtyPos, 5, 40, 0.6, 0.1)
				end
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(270) ) )
				for i = 1, 3 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.z = dirtyPos.z - rand.range(0, 100)
					self:DirtyDust(dirtyPos, 5, 40, 0.6, 0.1)
				end
				
			--̃ubN
			elseif self.mBlockType == "double" then
				centerPos:Set(350.45, 100+3, -382.83)
				centerPos:Set(centerPos + self.mBlockDiff)
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(0) ) )
				for i = 1, 3 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.x = dirtyPos.x - rand.range(0, 100)
					self:DirtyDust(dirtyPos, 5, 40, 0.6, 0.1)
				end
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(90) ) )
				for i = 1, 3 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.x = dirtyPos.x - rand.range(0, 100)
					self:DirtyDust(dirtyPos, 5, 40, 0.6, 0.1)
				end
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(0) ) )
				for i = 1, 3 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.z = dirtyPos.z + rand.range(0, 100)
					self:DirtyDust(dirtyPos, 5, 40, 0.6, 0.1)
				end
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(90) ) )
				for i = 1, 3 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.z = dirtyPos.z + rand.range(0, 100)
					self:DirtyDust(dirtyPos, 5, 40, 0.6, 0.1)
				end
			end
		end
	end

	--JEgŉ
	if self.mBlockEvent.mFlag == true and self.mBlockEvent.mCount == 60*2 then
		self.mBlockEvent:Change(false)
		self.mBlockVelocity:Set(0, 0, 0)
	end

	--JEgAbv
	self.mBlockEvent:CountUp(1)

	-------------------------------------------------------------------------------------------------------

	--ubNn}̏
	if self.mBlockComplete == true and self.mBlockEvent.mFlag == false and self.mBlockEndFlag == false then
		self.mBlockEndEvent:Change(true)
		self.mBlockEndFlag = true
	end

	--ubNn}Ă鎞̃Cxg
	if self.mBlockEndEvent.mFlag == true then

		--CxgJnu
		if self.mBlockEndEvent.mCount == 0 then
			self.mPlayer:Stop()             --vC[̓~
			self.mFade:Belt(true)           --f̂悤ȑтo
			self.mCamera:EnableMoving(true) --J̔Cӈړ\ɂ
		end

		--Jړ鏈iwʒuֈړj
		if 0 <= self.mBlockEndEvent.mCount and self.mBlockEndEvent.mCount < 60 then
			local cnt = self.mBlockEndEvent.mCount
			local maxPos = TMP_VECTOR:Set(190.6, 246, -273)
			local maxAt = TMP_VECTOR_A:Set(323.2, 160, -343.2)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)
		end

		--ubN鏈
		if 30 <= self.mBlockEndEvent.mCount and self.mBlockEndEvent.mCount < 30+60 then

			local trans  = TMP_MATRIX
			local cnt = self.mBlockEndEvent.mCount - 30

			self.mBlockFallHeight = GetSmoothValue(-108 * 2, 60*2-1, cnt)
			if self.mBlockFallHeight < -108 then self.mBlockFallHeight = -108 end
			trans:Translation(0, self.mBlockFallHeight, 0)
			self:SetListMatrix("double_block", "mDoubleBlock", trans)
		end

		--uԂɉ炷
		if self.mBlockEndEvent.mCount == 28+60 then
			WAVESOUND:Play(WPath("don"), Vector3C(350.45, 3, -382.83), ZERO_VECTOR, 150, 200)
			WAVESOUND:Play(WPath("don"), Vector3C(350.45, 3, -382.83), ZERO_VECTOR, 150, 200)
			WAVESOUND:Play(WPath("don"), Vector3C(350.45, 3, -382.83), ZERO_VECTOR, 150, 200)
		end
		
		--ubN̓y
		if 28+60 < self.mBlockEndEvent.mCount and self.mBlockEndEvent.mCount < 30+60+10 then
			local centerPos = TMP_VECTOR
			local edgeVec   = TMP_VECTOR_A:Set(55, 0, 55)
			local dirtyPos  = TMP_VECTOR_B
			local rot       = TMP_MATRIX_A
			centerPos:Set(350.45, 3, -382.83)
			edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(0) ) )
			for i = 1, 2 do
				dirtyPos:Set(centerPos + edgeVec)
				dirtyPos.x = dirtyPos.x - rand.range(0, 100)
				self:DirtyDust(dirtyPos, 8, 60, 0.7, 0.1)
			end
			edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(90) ) )
			for i = 1, 2 do
				dirtyPos:Set(centerPos + edgeVec)
				dirtyPos.x = dirtyPos.x - rand.range(0, 100)
				self:DirtyDust(dirtyPos, 8, 60, 0.7, 0.1)
			end
			edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(0) ) )
			for i = 1, 2 do
				dirtyPos:Set(centerPos + edgeVec)
				dirtyPos.z = dirtyPos.z + rand.range(0, 100)
				self:DirtyDust(dirtyPos, 8, 60, 0.7, 0.1)
			end
			edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(90) ) )
			for i = 1, 2 do
				dirtyPos:Set(centerPos + edgeVec)
				dirtyPos.z = dirtyPos.z + rand.range(0, 100)
				self:DirtyDust(dirtyPos, 8, 60, 0.7, 0.1)
			end
		end

		--Jړ鏈iwʒuJnj
		if self.mBlockEndEvent.mCount == 30+60 then

			--J̓KWŎZo
			local player = self.mPlayer
			self.mCamera:GetPosAt(false, false, player.mPosition, player.mAngle, player:GetUnitSpeed(), self.mMapVisualList)
		end

		--Jړ鏈ïʒuֈړj
		if 30+60 <= self.mBlockEndEvent.mCount and self.mBlockEndEvent.mCount < 30+60+60 then
			local cnt = 59 - (self.mBlockEndEvent.mCount - (30+60) )
			local maxPos = TMP_VECTOR:Set(190.6, 246, -273)
			local maxAt = TMP_VECTOR_A:Set(323.2, 160, -343.2)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)
		end

		--Cxg̏I
		if self.mBlockEndEvent.mCount == 30+60+60 then
			self.mFade:Belt(false)            --f̂悤ȑт
			self.mCamera:EnableMoving(false)  --J̔CӈړI
			self.mBlockEndEvent:Change(false) --Cxg̏I
		end
	end

	--JEgAbv
	self.mBlockEndEvent:CountUp(1)

	-------------------------------------------------------------------------------------------------------

	--Ԃꂽ̏
	if hold == true and self.mGearPushFlag == false and  gear_s == true and fixAnime == "push" then
		self.mGearPushEvent:Change(true)
		self.mGearPushFlag = true
	end

	--Ԃ̃Cxg
	if self.mGearPushEvent.mFlag == true then

		--CxgJnu
		if self.mGearPushEvent.mCount == 0 then
			self.mPlayer:Stop()              --vC[̓~
			self.mFade:Belt(true)            --f̂悤ȑтo
			self.mCamera:EnableMoving(true)  --J̔Cӈړ\ɂ

			--炷
			WAVESOUND:Play(WPath("zuri"), self.mPlayer.mPosition, ZERO_VECTOR, 150, 200)
			WAVESOUND:Play(WPath("zuri"), self.mPlayer.mPosition, ZERO_VECTOR, 150, 200)
			WAVESOUND:Play(WPath("zuri"), self.mPlayer.mPosition, ZERO_VECTOR, 150, 200)
		end

		--BGM̃{[
		if 5 <= self.mGearPushEvent.mCount and self.mGearPushEvent.mCount <= 60 + 5 then
			MP3SOUND:SetVolume(MPath("main"), (-1000 / 60) * self.mGearPushEvent.mCount + self.mBGMDiff)
		end

		--Jړ鏈iwʒuֈړj
		if 0 <= self.mGearPushEvent.mCount and self.mGearPushEvent.mCount < 60 then
			local cnt = self.mGearPushEvent.mCount
			local maxPos = TMP_VECTOR:Set(-170, 620, 357)
			local maxAt = TMP_VECTOR_A:Set(-278, 334, 461)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)
		end

		if self.mGearPushEvent.mCount == 30 then
			self.mLiftState:Change("insert") --Ԃ~߂
		end

		--ԂĂ
		if 0 <= self.mGearPushEvent.mCount and self.mGearPushEvent.mCount < 60*2 then

			local trans  = TMP_MATRIX
			local cnt = self.mGearPushEvent.mCount

			self.mGearPushSize = GetSmoothValue(73.66, 60*2-1, cnt) --self.mGearPushSize + (73.66 / 120)
			trans:Translation(-self.mGearPushSize, 0, 0)
			self:SetListMatrix("gear_r2_hit", "mGearR2Hit", trans)
			self.mGearR2:SetMatrix(trans)
			self.mPlayer.mPosition.x = self.mPlayer.mPosition.x - GetSmoothDiff(73.66, 60*2-1, cnt) --(73.66 / 120)
		end

		--vC[̉Ԃ
		if self.mGearPushEvent.mCount == 60*2 then
			self.mPlayer.mPushPullState:Change(false)
		end

		--J̈ʒu㏑
		if self.mGearPushEvent.mCount == 60*3 then
			self.mCamera.mTempPosition:Set(-170, 620, 357)
			self.mCamera.mTempAt:Set(-278, 334, 461)

			--Ԃz
			if self.mTakeBlockFlag == false then self.mLiftState:Change("spasm") end
		end

		--Jړ鏈iwʒuֈړj
		if 60*3 <= self.mGearPushEvent.mCount and self.mGearPushEvent.mCount < 60*4 then
			local cnt = self.mGearPushEvent.mCount - 60*3
			local maxPos = TMP_VECTOR:Set(600, 400, 0)
			local maxAt = TMP_VECTOR_A:Set(-300, 400, 0)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)
		end

		--IĂ΁A~Jn
		if self.mGearPushEvent.mCount == 60*3+10 and self.mTakeBlockFlag == true then
			self.mLiftState:Change("updown")
		end

		--IĂȂꍇŁAJړ鏈iwʒuJnj
		if self.mGearPushEvent.mCount == 60*6 and self.mTakeBlockFlag == false then

			--J̓KWŎZo
			local player = self.mPlayer
			self.mCamera:GetPosAt(false, false, player.mPosition, player.mAngle, player:GetUnitSpeed(), self.mMapVisualList)
		end

		--IĂ΁A炷
		if self.mGearPushEvent.mCount == 60*6-30 and self.mTakeBlockFlag == true then
			WAVESOUND:Play(WPath("mystery"), -700, 0)
		end
		
		--IĂꍇŁAJړ鏈iwʒuJnj
		if self.mGearPushEvent.mCount == 60*8 and self.mTakeBlockFlag == true then

			--J̓KWŎZo
			local player = self.mPlayer
			self.mCamera:GetPosAt(false, false, player.mPosition, player.mAngle, player:GetUnitSpeed(), self.mMapVisualList)
		end

		--IĂȂꍇŁAJړ鏈ïʒuֈړj
		if 60*6 <= self.mGearPushEvent.mCount and self.mGearPushEvent.mCount < 60*7 and self.mTakeBlockFlag == false then
			local cnt = 59 - (self.mGearPushEvent.mCount - 60*6)
			local maxPos = TMP_VECTOR:Set(600, 400, 0)
			local maxAt = TMP_VECTOR_A:Set(-300, 400, 0)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)

			--BGM̃{[グ
			MP3SOUND:SetVolume(MPath("main"), (-1000 / 60) * cnt + self.mBGMDiff)
		end

		--IĂꍇŁAJړ鏈ïʒuֈړj
		if 60*8 <= self.mGearPushEvent.mCount and self.mGearPushEvent.mCount < 60*9 and self.mTakeBlockFlag == true then
			local cnt = 59 - (self.mGearPushEvent.mCount - 60*8)
			local maxPos = TMP_VECTOR:Set(600, 400, 0)
			local maxAt = TMP_VECTOR_A:Set(-300, 400, 0)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)

			--BGM̃{[グ
			MP3SOUND:SetVolume(MPath("main"), (-1000 / 60) * cnt + self.mBGMDiff)
		end

		--IĂȂꍇŁACxg̏I
		if self.mGearPushEvent.mCount == 60*7 and self.mTakeBlockFlag == false then
			self.mFade:Belt(false)            --f̂悤ȑт
			self.mCamera:EnableMoving(false)  --J̔CӈړI
			self.mGearPushEvent:Change(false) --CxgI
		end

		--IĂꍇŁACxg̏I
		if self.mGearPushEvent.mCount == 60*9 and self.mTakeBlockFlag == true then
			self.mFade:Belt(false)            --f̂悤ȑт
			self.mCamera:EnableMoving(false)  --J̔CӈړI
			self.mGearPushEvent:Change(false) --CxgI
		end
	end

	--JEgAbv
	self.mGearPushEvent:CountUp(1)

	-------------------------------------------------------------------------------------------------------

	--܂ubNꂽ̏
	if hold == true and self.mTakeBlockFlag == false and jam_s == true and fixAnime == "pull" then
		self.mTakeBlockEvent:Change(true)
		self.mTakeBlockFlag = true
	end

	--܂ubNꂽ̃Cxg
	if self.mTakeBlockEvent.mFlag == true then

		--CxgJnu
		if self.mTakeBlockEvent.mCount == 0 then
			self.mPlayer:Stop()              --vC[̓~
			self.mFade:Belt(true)            --f̂悤ȑтo
			self.mCamera:EnableMoving(true)  --J̔Cӈړ\ɂ

			--炷
			WAVESOUND:Play(WPath("zuri"), self.mPlayer.mPosition, ZERO_VECTOR, 150, 200)
			WAVESOUND:Play(WPath("zuri"), self.mPlayer.mPosition, ZERO_VECTOR, 150, 200)
			WAVESOUND:Play(WPath("zuri"), self.mPlayer.mPosition, ZERO_VECTOR, 150, 200)
		end

		--BGM̃{[
		if 5 <= self.mTakeBlockEvent.mCount and self.mTakeBlockEvent.mCount <= 60 + 5 then
			MP3SOUND:SetVolume(MPath("main"), (-1000 / 60) * self.mTakeBlockEvent.mCount + self.mBGMDiff)
		end

		--Jړ鏈iwʒuֈړj
		if 0 <= self.mTakeBlockEvent.mCount and self.mTakeBlockEvent.mCount < 60 then
			local cnt = self.mTakeBlockEvent.mCount
			local maxPos = TMP_VECTOR:Set(-181, 512, -351)
			local maxAt = TMP_VECTOR_A:Set(-271, 326, -470)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)
		end

		--܂ubNĂ
		if 0 <= self.mTakeBlockEvent.mCount and self.mTakeBlockEvent.mCount < 60*2 then

			local trans  = TMP_MATRIX
			local cnt = self.mTakeBlockEvent.mCount

			self.mTakeBlockSize = GetSmoothValue(100, 60*2-1, cnt) --self.mTakeBlockSize + (100 / 120)
			trans:Translation(self.mTakeBlockSize, 0, 0)
			self:SetListMatrix("gear_block", "mGearBlock", trans)
			self.mPlayer.mPosition.x = self.mPlayer.mPosition.x + GetSmoothDiff(100, 60*2-1, cnt) --(100 / 120)
			
			--ubN̓y
			if self.mTakeBlockEvent.mCount % 5 == 0 then
				local centerPos = TMP_VECTOR
				local edgeVec   = TMP_VECTOR_A:Set(60, 0, 0)
				local dirtyPos  = TMP_VECTOR_B
				local rot       = TMP_MATRIX_A
				centerPos:Set(-237.91 - 100, 300, -458.8)
				centerPos.x = centerPos.x + self.mTakeBlockSize
				
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(0) ) )
				for i = 0, 12 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.z = dirtyPos.z - 55 + i * (110/13)
					self:DirtyDust(dirtyPos, 6, 30, 0.6, 0.1)
				end
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(180) ) )
				for i = 0, 12 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.z = dirtyPos.z - 55 + i * (110/13)
					self:DirtyDust(dirtyPos, 6, 30, 0.6, 0.1)
				end
				edgeVec:Set(0, 0, 55)
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(0) ) )
				for i = 1, 4 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.x = dirtyPos.x - rand.s_range(0, 65)
					self:DirtyDust(dirtyPos, 5, 40, 0.6, 0.1)
				end
				edgeVec:TransformCoord(rot:RotationY(DEG_ANGLE(180) ) )
				for i = 1, 4 do
					dirtyPos:Set(centerPos + edgeVec)
					dirtyPos.x = dirtyPos.x - rand.s_range(0, 65)
					self:DirtyDust(dirtyPos, 5, 40, 0.6, 0.1)
				end
			end			
		end

		--vC[̉Ԃ
		if self.mTakeBlockEvent.mCount == 60*2 then
			self.mPlayer.mPushPullState:Change(false)
		end

		--J̈ʒu㏑
		if self.mTakeBlockEvent.mCount == 60*3 then
			self.mCamera.mTempPosition:Set(-181, 512, -351)
			self.mCamera.mTempAt:Set(-271, 326, -470)
			self.mLiftState:Change("insert") --Ԃ~߂
		end

		--Jړ鏈iwʒuֈړj
		if 60*3 <= self.mTakeBlockEvent.mCount and self.mTakeBlockEvent.mCount < 60*4 then
			local cnt = self.mTakeBlockEvent.mCount - 60*3
			local maxPos = TMP_VECTOR:Set(600, 400, 0)
			local maxAt = TMP_VECTOR_A:Set(-300, 400, 0)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)
		end

		--tg𗎂Ƃ
		if self.mTakeBlockEvent.mCount == 60*4 then
			if self.mGearPushFlag == true then
				self.mLiftState:Change("downup")
			else
				self.mLiftState:Change("takeout")
			end
		end

		--EIĂȂꍇŁAJړ鏈iwʒuJnj
		if self.mTakeBlockEvent.mCount == 60*8 and self.mGearPushFlag == false then

			--J̓KWŎZo
			local player = self.mPlayer
			self.mCamera:GetPosAt(false, false, player.mPosition, player.mAngle, player:GetUnitSpeed(), self.mMapVisualList)
		end

		--EIĂꍇŁAJړ鏈iwʒuJnj
		if self.mTakeBlockEvent.mCount == 60*8 and self.mGearPushFlag == true then

			--J̓KWŎZo
			local player = self.mPlayer
			self.mCamera:GetPosAt(false, false, player.mPosition, player.mAngle, player:GetUnitSpeed(), self.mMapVisualList)
		end

		--EIĂ΁A炷
		if self.mTakeBlockEvent.mCount == 60*8-30 and self.mGearPushFlag == true then
			WAVESOUND:Play(WPath("mystery"), -700, 0)
		end

		--EIĂȂꍇŁAJړ鏈ïʒuֈړj
		if 60*8 <= self.mTakeBlockEvent.mCount and self.mTakeBlockEvent.mCount < 60*9 and self.mGearPushFlag == false then
			local cnt = 59 - (self.mTakeBlockEvent.mCount - 60*8)
			local maxPos = TMP_VECTOR:Set(600, 400, 0)
			local maxAt = TMP_VECTOR_A:Set(-300, 400, 0)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)

			--BGM̃{[グ
			MP3SOUND:SetVolume(MPath("main"), (-1000 / 60) * cnt + self.mBGMDiff)
		end

		--EIĂꍇŁAJړ鏈ïʒuֈړj
		if 60*10 <= self.mTakeBlockEvent.mCount and self.mTakeBlockEvent.mCount < 60*11 and self.mGearPushFlag == true then
			local cnt = 59 - (self.mTakeBlockEvent.mCount - 60*10)
			local maxPos = TMP_VECTOR:Set(600, 400, 0)
			local maxAt = TMP_VECTOR_A:Set(-300, 400, 0)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)

			--BGM̃{[グ
			MP3SOUND:SetVolume(MPath("main"), (-1000 / 60) * cnt + self.mBGMDiff)
		end

		--EIĂȂꍇŁACxg̏I
		if self.mTakeBlockEvent.mCount == 60*9 and self.mGearPushFlag == false then
			self.mFade:Belt(false)            --f̂悤ȑт
			self.mCamera:EnableMoving(false)  --J̔CӈړI
			self.mTakeBlockEvent:Change(false) --CxgI
		end

		--EIĂꍇŁACxg̏I
		if self.mTakeBlockEvent.mCount == 60*11 and self.mGearPushFlag == true then
			self.mFade:Belt(false)            --f̂悤ȑт
			self.mCamera:EnableMoving(false)  --J̔CӈړI
			self.mTakeBlockEvent:Change(false) --CxgI
		end
	end

	--JEgAbv
	self.mTakeBlockEvent:CountUp(1)
end